/* Process model C form file: ip_gwy.pr.c */
/* Portions of this file copyright 1992, 1996, 1998 by MIL 3, Inc. */



/* This variable carries the header into the object file */
static const char ip_gwy_pr_c [] = "MIL_3_Tfile_Hdr_ 60L 30A op_runsim 7 38FBBA7F 38FBBA7F 1 chrono.ite.gmu.edu vmukkama 0 0 none none 0 0 none 0 0 0 0 0 0";


/* OPNET system definitions */
#include <opnet.h>

#if defined (__cplusplus)
extern "C" {
#endif
FSM_EXT_DECS
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif


/* Header Block */

#define TRACE 	if(0)

#include "ip_frag_sup.h"
/* Macros Used to Represent Transitions. */
#define QUEUE_EMPTY     	(op_q_empty ())
#define SVC_COMPLETION  	((op_intrpt_type () == OPC_INTRPT_SELF) && (op_intrpt_code () == 0))
#define ARRIVAL         	op_intrpt_type () == OPC_INTRPT_STRM
#define END_SIM				op_intrpt_type () == OPC_INTRPT_ENDSIM

#define MAC_UPD_OUTSTAT		0
#define THRU_OUT 		1
#define THROUGHPUT		2
#define CUMM_THRU 		3
#define BIT_THRU 		4
#define CUMM_BIT_THRU 		5
#define Lsa_Vs_Other_Stat	6
#define CTRL_PKTS_OVERFLOW	7  /*added by Jiemei, Mar 28, 97*/
#define BE_PKTS_OVERFLOW	8  /*added by Jiemei, Mar 28,97*/
#define RESV_PKTS_OVERFLOW	9  /*added by Jiemei, Mar 28, 97*/
#define TOTAL_DESTROY_STAT      10 /*added by JIemei, Apr 3, 97*/

#define TRAFFIC_LOAD		11 /*added by DG and Jiemei 11/27 97 */
#define TRAFFIC_LOAD_SEC	12 /*added by DG and Jiemei 11/27 97 */

#define NODE_CTRL_PKTS_OVERFLOW	13  /*added by Jiemei, Mar 28, 97*/
#define NODE_BE_PKTS_OVERFLOW	14  /*added by Jiemei, Mar 28,97*/
#define NODE_RESV_PKTS_OVERFLOW	15  /*added by Jiemei, Mar 28, 97*/

#define SEC_CTRL_PKTS_OVERFLOW	16  /*added by Jiemei, Mar 28, 97*/
#define SEC_BE_PKTS_OVERFLOW	17  /*added by Jiemei, Mar 28,97*/
#define SEC_RESV_PKTS_OVERFLOW	18  /*added by Jiemei, Mar 28, 97*/

#define SEC_NODE_CTRL_PKTS_OVERFLOW	19  /*added by Jiemei, Mar 28, 97*/
#define SEC_NODE_BE_PKTS_OVERFLOW	20  /*added by Jiemei, Mar 28,97*/
#define SEC_NODE_RESV_PKTS_OVERFLOW	21  /*added by Jiemei, Mar 28, 97*/

#define RAW_TRAFFIC_LOAD	22 /*added by DG and Jiemei 11/27 97 */
#define RAW_TRAFFIC_LOAD_SEC	23 /*added by DG and Jiemei 11/27 97 */


#define ON						1
#define OFF 					0
#define BUSY					1
#define IDLE 					0
#define TRUE					1
#define FALSE 					0
#define UNDEFINED				-1

#define RSVP_STREAM 			14
#define QOSPF_STREAM 			13
#define IGMP_STREAM				12
#define TCP_STREAM				11

#define VL 		if(ON)
#define IPVL 		if(OFF)
#define PROBE_ON 	if(ON)
#define PROBE_OFF 	if(OFF)

#define InLIST_SIZE 			10

#define MAX_NO_LINKS 			10
#define MAX_NO_GRPS 			50

#define IS_MULTICAST			500
#define ALL_SPF_ROUTER_NET		400
#define ALL_SPF_ROUTER_NODE		5
#define ALL_D_ROUTER_NET		400
#define ALL_D_ROUTER_NODE		6

#define DEF_STREAM				110

#define CONTROL_PKTS			0
#define BE_PKTS					1
#define RESV_PKTS				2

#define MAX_LEN_CONTROL_BUFFER		20
#define MAX_LEN_RESV_BUFFER		40
#define MAX_LEN_BE_BUFFER		40

#define IGMP_PROTOCOL_ID		9
#define TCP_PROTOCOL_ID			12
#define UDP_PROTOCOL_ID			20
#define RSVP_PROTOCOL_ID		46
#define QOSPF_PROTOCOL_ID		89

#define IP_DEFAULT_TTL			32

struct MC
{  int interface[MAX_NO_LINKS];
   int mtu[MAX_NO_LINKS];
   int infValid;		
/* Last field added by DG, 11/8/97, Save the SourceNet of last SPT. set to -1 if membership change. */
};
typedef struct MC mc_id;

/*
** IP Address structure
*/
typedef struct {
	int NetNum;
	int NodeNum;
} IPAddress;

/*
** Session Directory Structure
*/
typedef struct {
    IPAddress SenderAddr;
    IPAddress DestAddr;
    int SenderPort;
    double Bandwidth;
    double Delay;
}sd;
 
/*
** Function Prototypes that are being used in this module
*/
 
int get_prio();
int CheckIfResvPkt( int, int, int, int );

/*added by Jiemei*/
double ctrl_pkts_overflow, be_pkts_overflow, resv_pkts_overflow;
double sec_ctrl_overflow, sec_be_overflow, sec_resv_overflow;

extern double total_destroy;

#define CAPACITY 1250000                /* Capacity of the link from GWY to ABR. */


/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		_fstack_local_info.last_line_passed = __LINE__ - _block_origin;
#define	BOUT	BIN
#define	BINIT	_fstack_local_info.last_line_passed = 0; _block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	/* State Variables */
	int                     		server_busy;
	int                     		rte_tab[501];
	int                     		gwy_type;
	int                     		Indep_Rou;
	int                     		mc_join[100][100];
	double                  		pk_sent;
	double                  		tmpPkSent;
	double                  		sizeofpacket;
	double                  		tmpsizeofpacket;
	double                  		service_rate;
	double                  		tmp_sim_time;
	double                  		tmp_sim_time1;
	double                  		tracking_interval;
	double                  		ControlPktBitsSer;
	Objid                   		own_id;
	Objid                   		sub_netid;
	Objid                   		qospf_objid;
	Objid                   		rsvp_objid;
	int	                    		net_num0;
	int	                    		node_num0;
	int	                    		net_num1;
	int	                    		node_num1;
	int	                    		net_num2;
	int	                    		node_num2;
	int	                    		net_num3;
	int	                    		node_num3;
	int	                    		net_num4;
	int	                    		node_num4;
	int	                    		net_num5;
	int	                    		node_num5;
	int	                    		net_num6;
	int	                    		node_num6;
	int	                    		net_num7;
	int	                    		node_num7;
	int	                    		net_num8;
	int	                    		node_num8;
	int	                    		net_num9;
	int	                    		node_num9;
	Ici*	                   		arp_iciptr;
	ip_dgram_list*	         		dgram_list_ptr;
	int	                    		def_str;
	int	                    		default_ttl;
	int	                    		n_links;
	mc_id	                  		mc_table[MAX_NO_GRPS];
	int                     		print_flag;
	int                     		control_pk_queue;
	int                     		resv_pk_queue;
	int                     		be_pk_queue;
	int                     		SourceNet;
	int                     		GrpId;
	double                  		TraftoNet;
	double                  		TrafperSec;
	double                  		lastTrafTime;
	double                  		sec_node_ctrl_overflow;
	double                  		sec_node_be_overflow;
	double                  		sec_node_resv_overflow;
	double                  		node_ctrl_overflow;
	double                  		node_be_overflow;
	double                  		node_resv_overflow;
	double                  		RawTraftoNet;
	double                  		RawTrafperSec;
	} ip_gwy_state;

#define pr_state_ptr            		((ip_gwy_state*) SimI_Mod_State_Ptr)
#define server_busy             		pr_state_ptr->server_busy
#define rte_tab                 		pr_state_ptr->rte_tab
#define gwy_type                		pr_state_ptr->gwy_type
#define Indep_Rou               		pr_state_ptr->Indep_Rou
#define mc_join                 		pr_state_ptr->mc_join
#define pk_sent                 		pr_state_ptr->pk_sent
#define tmpPkSent               		pr_state_ptr->tmpPkSent
#define sizeofpacket            		pr_state_ptr->sizeofpacket
#define tmpsizeofpacket         		pr_state_ptr->tmpsizeofpacket
#define service_rate            		pr_state_ptr->service_rate
#define tmp_sim_time            		pr_state_ptr->tmp_sim_time
#define tmp_sim_time1           		pr_state_ptr->tmp_sim_time1
#define tracking_interval       		pr_state_ptr->tracking_interval
#define ControlPktBitsSer       		pr_state_ptr->ControlPktBitsSer
#define own_id                  		pr_state_ptr->own_id
#define sub_netid               		pr_state_ptr->sub_netid
#define qospf_objid             		pr_state_ptr->qospf_objid
#define rsvp_objid              		pr_state_ptr->rsvp_objid
#define net_num0                		pr_state_ptr->net_num0
#define node_num0               		pr_state_ptr->node_num0
#define net_num1                		pr_state_ptr->net_num1
#define node_num1               		pr_state_ptr->node_num1
#define net_num2                		pr_state_ptr->net_num2
#define node_num2               		pr_state_ptr->node_num2
#define net_num3                		pr_state_ptr->net_num3
#define node_num3               		pr_state_ptr->node_num3
#define net_num4                		pr_state_ptr->net_num4
#define node_num4               		pr_state_ptr->node_num4
#define net_num5                		pr_state_ptr->net_num5
#define node_num5               		pr_state_ptr->node_num5
#define net_num6                		pr_state_ptr->net_num6
#define node_num6               		pr_state_ptr->node_num6
#define net_num7                		pr_state_ptr->net_num7
#define node_num7               		pr_state_ptr->node_num7
#define net_num8                		pr_state_ptr->net_num8
#define node_num8               		pr_state_ptr->node_num8
#define net_num9                		pr_state_ptr->net_num9
#define node_num9               		pr_state_ptr->node_num9
#define arp_iciptr              		pr_state_ptr->arp_iciptr
#define dgram_list_ptr          		pr_state_ptr->dgram_list_ptr
#define def_str                 		pr_state_ptr->def_str
#define default_ttl             		pr_state_ptr->default_ttl
#define n_links                 		pr_state_ptr->n_links
#define mc_table                		pr_state_ptr->mc_table
#define print_flag              		pr_state_ptr->print_flag
#define control_pk_queue        		pr_state_ptr->control_pk_queue
#define resv_pk_queue           		pr_state_ptr->resv_pk_queue
#define be_pk_queue             		pr_state_ptr->be_pk_queue
#define SourceNet               		pr_state_ptr->SourceNet
#define GrpId                   		pr_state_ptr->GrpId
#define TraftoNet               		pr_state_ptr->TraftoNet
#define TrafperSec              		pr_state_ptr->TrafperSec
#define lastTrafTime            		pr_state_ptr->lastTrafTime
#define sec_node_ctrl_overflow  		pr_state_ptr->sec_node_ctrl_overflow
#define sec_node_be_overflow    		pr_state_ptr->sec_node_be_overflow
#define sec_node_resv_overflow  		pr_state_ptr->sec_node_resv_overflow
#define node_ctrl_overflow      		pr_state_ptr->node_ctrl_overflow
#define node_be_overflow        		pr_state_ptr->node_be_overflow
#define node_resv_overflow      		pr_state_ptr->node_resv_overflow
#define RawTraftoNet            		pr_state_ptr->RawTraftoNet
#define RawTrafperSec           		pr_state_ptr->RawTrafperSec

/* This macro definition will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE
#define FIN_PREAMBLE	ip_gwy_state *op_sv_ptr = pr_state_ptr;


/* Function Block */

enum { _block_origin = __LINE__ };
int  get_prio(kpt)
	Packet* kpt;
{
	int pro;
	op_pk_nfd_get(kpt,"prot_id",&pro);
	switch(pro) 
	{
/* Commented by DG, 10/1 */
/*		case 89: pro = 0;
			 break;
		case 46: pro = 0;
			 break;
		case 20: pro = 1;
			 break;
		case 9: pro = 1;
			 break;
		case 12: pro = 2;
			 break;
*/
/* Changed by DG, 10/1 */
		case QOSPF_PROTOCOL_ID: pro = CONTROL_PKTS;
					break;
		case RSVP_PROTOCOL_ID:  pro = CONTROL_PKTS;
					break;
		case UDP_PROTOCOL_ID:	pro = BE_PKTS;
					break;
		case IGMP_PROTOCOL_ID:	pro = BE_PKTS;
					break;
		case TCP_PROTOCOL_ID: 	pro = RESV_PKTS;
					break;
		default:  op_sim_end("Whaaaat pk is this?","","","");
	}
	return(pro);
}

int CheckIfResvPkt( int s_net, int s_node, int dest_net, int dest_node )
{
    /*  sd *tsd;  */
    /*  tsd = (sd*) op_ima_obj_svar_get( rsvp_objid, "SessDirectory" );  */
    /*  if( tsd[dest_node].SenderAddr.NetNum == s_net &&  */
        /*  tsd[dest_node].SenderAddr.NodeNum == s_node )  */
	if( dest_node > 10 && dest_node <= 30 )
    {
        return 1;
    }
    else
        return 0;
}

/* End of Function Block */

#if defined (__cplusplus)
extern "C" {
#endif
	void ip_gwy (void);
	Compcode ip_gwy_init (void **);
	void ip_gwy_diag (void);
	void ip_gwy_terminate (void);
	void ip_gwy_svar (void *, const char *, char **);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
ip_gwy (void)
	{
	int _block_origin = 0;
	FIN (ip_gwy ());
	if (1)
		{
		Objid		dup_lk_id;
		double          thru, thru1, thru2, thru3, pk_svc_time;
		int             insert_ok;
		int				outstrm, mtu, frag,resp,op,UP;
		int				next_net, next_node;
		int				dest_net, dest_node,s_net,s_node,protocol;
		int				i,j,frag_accum, num_frags;
		int				frag_size, data_size, len,data_len;
		int				header_size, ttl;
		char			str0 [512], str1 [512];
		Packet			*pkptr, *ip_pkptr, *frag_ptr;
		Packet			*data_pkptr;
		
		int 			  term,join,grp_id,in_strm,join_pk;
		


		FSM_ENTER (ip_gwy)

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (init) enter executives **/
			FSM_STATE_ENTER_FORCED (0, state0_enter_exec, "init", "ip_gwy () [init enter execs]")
				{
				pk_sent = 0;
				/* initially the server is idle */
				server_busy = IDLE;
				
				/* get queue module's own object id */
				own_id = op_id_self ();
				qospf_objid = op_topo_assoc( own_id, OPC_TOPO_ASSOC_OUT, OPC_OBJMTYPE_MODULE, QOSPF_STREAM );
				/* get assigned value of server processing rate */
				op_ima_obj_attr_get (own_id, "service_rate", &service_rate);
				op_ima_obj_attr_get (own_id, "Indep_Rou", &Indep_Rou);
				
				
				/* Obtain the assigned network and node numbers. */
				/* Note that this IP model supports multiple addresses */
				/* for gateways which may be members of several networks. */
				op_ima_obj_attr_get (own_id, "net_num0", &net_num0);
				op_ima_obj_attr_get (own_id, "net_num1", &net_num1);
				op_ima_obj_attr_get (own_id, "net_num2", &net_num2);
				op_ima_obj_attr_get (own_id, "node_num0", &node_num0);
				op_ima_obj_attr_get (own_id, "node_num1", &node_num1);
				op_ima_obj_attr_get (own_id, "node_num2", &node_num2);
				op_ima_obj_attr_get (own_id, "net_num3", &net_num3);
				op_ima_obj_attr_get (own_id, "node_num3", &node_num3);
				op_ima_obj_attr_get (own_id, "net_num4", &net_num4);
				op_ima_obj_attr_get (own_id, "node_num4", &node_num4);
				op_ima_obj_attr_get (own_id, "net_num5", &net_num5);
				op_ima_obj_attr_get (own_id, "node_num5", &node_num5);
				op_ima_obj_attr_get (own_id, "net_num6", &net_num6);
				op_ima_obj_attr_get (own_id, "node_num6", &node_num6);
				op_ima_obj_attr_get (own_id, "net_num7", &net_num7);
				op_ima_obj_attr_get (own_id, "node_num7", &node_num7);
				op_ima_obj_attr_get (own_id, "net_num8", &net_num8);
				op_ima_obj_attr_get (own_id, "node_num8", &node_num8);
				op_ima_obj_attr_get (own_id, "net_num9", &net_num9);
				op_ima_obj_attr_get (own_id, "node_num9", &node_num9);
				op_ima_obj_attr_get (own_id, "DEF_STRM", &def_str);
				op_ima_obj_attr_get (own_id, "TRACK_INTVL", &tracking_interval); 
				
				
				
				/*Added by Jiemei*/
				TRACE printf("Gwy_Ip: MyObjId %d  service_rate %f  Indep_Rou %d  net_num %d %d %d %d %d %d %d %d %d %d",own_id,service_rate,Indep_Rou,net_num0,net_num1,net_num2,net_num3,net_num4,net_num5,net_num6,net_num7,net_num8,net_num9);
				TRACE printf("  node_num %d %d %d %d %d %d %d %d %d %d  def_str %d  Track_Intvl %f\n",node_num0,node_num1,node_num2,node_num3,node_num4,node_num5,node_num6,node_num7,node_num8,node_num9,def_str,tracking_interval);
				service_rate=520;
				
				/* Create a datagram list used to hold datagram fragments */
				/* Until complete datagrams can be reconstructed. */
				dgram_list_ptr = ip_frag_sup_setup ();
				
				
				/* Create an Ici for communicating destination addresses to arp. */
				arp_iciptr = op_ici_create ("ip_arp_req");
				
				/*
				for(i = 0; i < MAX_NO_GRPS; ++i)
				{
				  for(j = 0; j < MAX_NO_LINKS; ++j)
				    {  
						mc_table[i].interface[j]=-1;
				        mc_table[i].mtu[j] = 4096;
				    }
				} 
				*/
				
				/*memset(mc_table,-1,sizeof(mc_id));*/
				memset( mc_table, UNDEFINED, sizeof(mc_id)*MAX_NO_GRPS );  /*changed by Jiemei mar 23 97*/
				
				if(!Indep_Rou)sub_netid = op25_topo_parent(op25_topo_parent(own_id));
				   else sub_netid=op25_topo_parent(own_id);
				n_links = op_topo_assoc_count(sub_netid,OPC_TOPO_ASSOC_IN,OPC_OBJTYPE_LKSIMP);
				
				VL	IPVL	printf("N-links at %d = %d\n",net_num0,n_links);
				
				if(op_id_to_type(sub_netid) == OPC_OBJTYPE_SUBNET) gwy_type = 1;
				  else gwy_type = 0;
				
				/* for(i=0;, i< n_links ; ++i){
				    dup_lk_id = op_topo_assoc(sub_netid,OPC_TOPO_ASSOC_IN, OPC_OBJTYPE_LKDUP,i);
				    net_id = op_topo_assoc(dup_lk_id,OPC_TOPO_ASSOC_IN,OPC_OBJTYPE_SUBNET,0);
						}*/
				/*printf("N_links for %d.%d = %d\n",net_num0, node_num0,n_links);*/
				
				/*  for(i=0;i<500;++i) rte_tab[i] = -1;    */
				
				memset( rte_tab, UNDEFINED, sizeof(int)*500 ); 
				
				print_flag = ON;
				
				tmp_sim_time = 0;
				tmp_sim_time1 = 0;
				sizeofpacket = 0;
				tmpsizeofpacket = 0;
				
				/*added by Jiemei, mar 28, 97*/
				ctrl_pkts_overflow=0;
				be_pkts_overflow=0;
				resv_pkts_overflow=0;
				
				sec_ctrl_overflow=0;
				sec_be_overflow=0;
				sec_resv_overflow=0;
				
				sec_node_ctrl_overflow=0;
				sec_node_be_overflow=0;
				sec_node_resv_overflow=0;
				
				node_ctrl_overflow=0;
				node_be_overflow=0;
				node_resv_overflow=0;
				
				
				/*no_route_destroy=0;*/
				total_destroy=0;
				TraftoNet = 0;
				TrafperSec = 0;
				lastTrafTime = 0;
				
				RawTraftoNet = 0;
				RawTrafperSec = 0;
				
				}


			/** state (init) exit executives **/
			FSM_STATE_EXIT_FORCED (0, state0_exit_exec, "init", "ip_gwy () [init exit execs]")
				{
				}


			/** state (init) transition processing **/
			FSM_INIT_COND (ARRIVAL)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("init")

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 1, state1_enter_exec, ;)
				FSM_CASE_TRANSIT (1, 2, state2_enter_exec, ;)
				}
				/*---------------------------------------------------------*/



			/** state (arrival) enter executives **/
			FSM_STATE_ENTER_FORCED (1, state1_enter_exec, "arrival", "ip_gwy () [arrival enter execs]")
				{
				/* 
				** Acquire the arriving packet. Multiple arriving streams are supported. 
				*/
				in_strm = op_intrpt_strm();
				pkptr = op_pk_get (in_strm);
				
				/* 
				** If the received packet does not have a time-to-live field assignment, place the default value 
				** in this field. In  this model, ttl is treated as a  hop allowance decremented by one prior to 
				** each  transmission. If the  decremented counter  reaches zero, the packet  is not transmitted 
				*/
				if (!op_pk_nfd_is_set (pkptr, "ttl"))
				{
					op25_pk_nfd_set (pkptr, "ttl", IP_DEFAULT_TTL);
				}
				op25_pk_nfd_set(pkptr,"strm",in_strm);
				
				PROBE_ON
				{
				/* Added by DG and Jiemei, 11/27,    
				 Caculate traffic to the network, instrm = 0
				*/
				
				    if (in_strm == 0)
				    {
				        double load;
				
				/*op_pk_nfd_get( pkptr, "dest_node", &dest_node );
				op_pk_nfd_get( pkptr, "dest_net", &dest_net );
				op_pk_nfd_get( pkptr, "src_net", &s_net );
				op_pk_nfd_get( pkptr, "src_node", &s_node );
				printf("%f (%d.%d) receive the packet(%d bits) from the local FDDI Ring:(%d.%d) to (%d.%d)\n",
				op_sim_time(),net_num0,node_num0,op_pk_total_size_get(pkptr),s_net, s_node, dest_net,dest_node);
				*/
				
				        RawTraftoNet = RawTraftoNet + op_pk_total_size_get(pkptr );
				        RawTrafperSec =  RawTrafperSec + op_pk_total_size_get(pkptr);
				/*printf("%f (%d.%d) RawTraftoNet= %f  RawTrafperSec = %f \n",
					op_sim_time(),net_num0, node_num0,RawTraftoNet, RawTrafperSec); */
				        load = RawTraftoNet / op_sim_time() / CAPACITY;
				        op_stat_local_write(RAW_TRAFFIC_LOAD, load );
				    }
				}
				  
				/*
				** Each packet is enqueued at the tail of its corresponding queue. In this model to simulate the
				** resource  reservation behaviour, three  subqueues one  for control packets, one  for resource 
				** requesting traffic and the other for best effort traffic are implemented. The control packets
				** queue is given top priority, then the resource requesting traffic queue and least priority is
				** given to the best effort traffic queue
				*/
				switch( get_prio(pkptr) )
				{
					case CONTROL_PKTS :
						if( control_pk_queue <= MAX_LEN_CONTROL_BUFFER )
						{
							if( op_subq_pk_insert( get_prio(pkptr), pkptr, OPC_QPOS_TAIL) != OPC_QINS_OK )
							{
								total_destroy++;
				
				                                op_stat_local_write(TOTAL_DESTROY_STAT,total_destroy);    
				
								TRACE printf("Insert packet into control subqueue failure\n"); /*added by Jiemei*/	
								op_pk_destroy(pkptr);
								insert_ok = FALSE;
							}
							else
							{
								control_pk_queue++;
								insert_ok = TRUE;
							}
						}
						else
						{
							/*added by Jiemei , Mar 28, 97*/
							PROBE_ON
							{	
								ctrl_pkts_overflow++;
								sec_ctrl_overflow++;
								node_ctrl_overflow++;
								sec_node_ctrl_overflow++;
				
								op_stat_local_write(CTRL_PKTS_OVERFLOW,ctrl_pkts_overflow);
								op_stat_local_write(NODE_CTRL_PKTS_OVERFLOW,node_ctrl_overflow);
							}
							total_destroy++;
				
				                        op_stat_local_write(TOTAL_DESTROY_STAT,total_destroy);    
							
							op_pk_destroy(pkptr);
							insert_ok = FALSE;
						}
					break;
					case RESV_PKTS :
						if( resv_pk_queue <= MAX_LEN_RESV_BUFFER )
						{
							if( op_subq_pk_insert( get_prio(pkptr), pkptr, OPC_QPOS_TAIL) != OPC_QINS_OK )
							{
								total_destroy++;
				
								op_stat_local_write(TOTAL_DESTROY_STAT,total_destroy);
								op_pk_destroy(pkptr);
								insert_ok = FALSE;
							}
							else
							{
								insert_ok = TRUE;
								resv_pk_queue++;
							}
						}
						else
						{	
							/* added by Jiemei, Mar 28, 97*/
							PROBE_ON
							{
								resv_pkts_overflow++;
								sec_resv_overflow++;
								node_resv_overflow++;
								sec_node_resv_overflow++;
				
								op_stat_local_write(RESV_PKTS_OVERFLOW,resv_pkts_overflow);
								op_stat_local_write(NODE_RESV_PKTS_OVERFLOW,node_resv_overflow);
							}
							total_destroy++;
							op_stat_local_write(TOTAL_DESTROY_STAT,total_destroy);
				
							op_pk_destroy(pkptr);
							insert_ok = FALSE;
						}
					break;
					case BE_PKTS :
						if( be_pk_queue <= MAX_LEN_BE_BUFFER )
						{
							/*added by Jiemei*/
							int result;
				
							if( (result=op_subq_pk_insert( get_prio(pkptr), pkptr, OPC_QPOS_TAIL)) != OPC_QINS_OK )
							{
								total_destroy++;
								op_stat_local_write(TOTAL_DESTROY_STAT,total_destroy);
								TRACE printf("Insert packet into BE-subqueue failure. Error no=%d queue size=%d\n",result,be_pk_queue);
				
								op_pk_destroy(pkptr);
								insert_ok = FALSE;
							}
							else
							{
								insert_ok = TRUE;
								be_pk_queue++;
							}
						}
						else
						{
							/*added by Jiemei, mar 28,97*/ 
							PROBE_ON
							{
								be_pkts_overflow++;
								sec_be_overflow++;
								node_be_overflow++;
								sec_node_be_overflow++;
				
								op_stat_local_write(BE_PKTS_OVERFLOW,be_pkts_overflow);
								op_stat_local_write(NODE_BE_PKTS_OVERFLOW,node_be_overflow);
							}
							total_destroy++;
							op_stat_local_write(TOTAL_DESTROY_STAT,total_destroy);
				
							op_pk_destroy(pkptr);
							insert_ok = FALSE;
						}
					break;
					default : break;
				}
				}


			/** state (arrival) exit executives **/
			FSM_STATE_EXIT_FORCED (1, state1_exit_exec, "arrival", "ip_gwy () [arrival exit execs]")
				{
				
				}


			/** state (arrival) transition processing **/
			FSM_INIT_COND (!server_busy && insert_ok)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("arrival")

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 3, state3_enter_exec, ;)
				FSM_CASE_TRANSIT (1, 2, state2_enter_exec, ;)
				}
				/*---------------------------------------------------------*/



			/** state (idle) enter executives **/
			FSM_STATE_ENTER_UNFORCED (2, state2_enter_exec, "idle", "ip_gwy () [idle enter execs]")
				{
				/* added by Jiemei */
				
				/*if (op_sim_time()>10.99) printf ("GWY_IP total destroy %d\n",total_destroy);*/
				
				double interval;
				
				interval = op_sim_time() - lastTrafTime;
				if ( interval >= 1 )
				{
					double load;
					load = TrafperSec / interval / CAPACITY;
				 	op_stat_local_write(TRAFFIC_LOAD_SEC, load );
					TrafperSec = 0;
				
					load = RawTrafperSec / interval / CAPACITY;
				 	op_stat_local_write(RAW_TRAFFIC_LOAD_SEC, load );
				/*printf("(%d,%d) RawTraftoNet = %f RawTrafperSec = %f  load per sec = %f  interval= %f\n",
					net_num0, node_num0, RawTraftoNet, RawTrafperSec,load,interval); */
					RawTrafperSec = 0;
				
					op_stat_local_write(SEC_CTRL_PKTS_OVERFLOW, sec_ctrl_overflow / interval );
					sec_ctrl_overflow = 0;
					op_stat_local_write(SEC_NODE_CTRL_PKTS_OVERFLOW, sec_node_ctrl_overflow / interval);
					sec_node_ctrl_overflow = 0;
				
					op_stat_local_write(SEC_BE_PKTS_OVERFLOW, sec_be_overflow / interval);
					sec_be_overflow = 0;
					op_stat_local_write(SEC_NODE_BE_PKTS_OVERFLOW, sec_node_be_overflow / interval);
					sec_node_be_overflow = 0;
				
					op_stat_local_write(SEC_RESV_PKTS_OVERFLOW, sec_resv_overflow / interval);
					sec_resv_overflow = 0;
					op_stat_local_write(SEC_NODE_RESV_PKTS_OVERFLOW, sec_node_resv_overflow / interval);
					sec_node_resv_overflow = 0;
				
					lastTrafTime = op_sim_time();
				}
				}


			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (5,ip_gwy)


			/** state (idle) exit executives **/
			FSM_STATE_EXIT_UNFORCED (2, state2_exit_exec, "idle", "ip_gwy () [idle exit execs]")
				{
				}


			/** state (idle) transition processing **/
			FSM_INIT_COND (ARRIVAL)
			FSM_TEST_COND (SVC_COMPLETION)
			FSM_TEST_LOGIC ("idle")

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 1, state1_enter_exec, ;)
				FSM_CASE_TRANSIT (1, 4, state4_enter_exec, ;)
				}
				/*---------------------------------------------------------*/



			/** state (svc_start) enter executives **/
			FSM_STATE_ENTER_FORCED (3, state3_enter_exec, "svc_start", "ip_gwy () [svc_start enter execs]")
				{
				pk_svc_time = 1.0 / service_rate;	/* time required to complete service of the packet */
				
				/* 
				** schedule an interrupt for this process at the time where service ends. 
				*/
				op_intrpt_schedule_self (op_sim_time () + pk_svc_time, 0);
				server_busy = BUSY;
				}


			/** state (svc_start) exit executives **/
			FSM_STATE_EXIT_FORCED (3, state3_exit_exec, "svc_start", "ip_gwy () [svc_start exit execs]")
				{
				}


			/** state (svc_start) transition processing **/
			FSM_TRANSIT_FORCE (2, state2_enter_exec, ;)
				/*---------------------------------------------------------*/



			/** state (svc_compl) enter executives **/
			FSM_STATE_ENTER_FORCED (4, state4_enter_exec, "svc_compl", "ip_gwy () [svc_compl enter execs]")
				{
				int i,j;
				UP = 0;
				
				
				/*added by Jiemei, Mar 28, 97*/
				/*if (op_sim_time()>14)
				{
				printf("Routing table for Gwy/Router Net_num %d\n ",net_num0);
				for (i=0;i<10;i++)
				{
					for(j=0;j<50;j++)
					{
						printf("%d ",rte_tab[i*50+j]);
					}	
					printf("\n");
				}
				printf("\n");
				}*/
				
				/* 
				** extract packet at head of queue this is the packet just finishing service 
				*/
				for(i = 0; i < 3; i++)
				{
					if(op_subq_empty(i) == OPC_FALSE)
					{
						pkptr = op_subq_pk_remove (i, OPC_QPOS_HEAD);
						switch(i)
						{
							case CONTROL_PKTS:
								control_pk_queue--;
								ControlPktBitsSer = ControlPktBitsSer + op_pk_total_size_get( pkptr );
							break;
							case RESV_PKTS:
								resv_pk_queue--;
							break;
							case BE_PKTS:
								be_pk_queue--;
							break;
							default : break;
						}
				
						break;
					}
				}
				
				pk_sent++;
				op_stat_local_write(CUMM_THRU, pk_sent);
				
				thru = pk_sent/op_sim_time();
				op_stat_local_write(THRU_OUT, thru);
				
				sizeofpacket = sizeofpacket + op_pk_total_size_get( pkptr );
				thru2 = sizeofpacket;
				op_stat_local_write(CUMM_BIT_THRU, thru2);
				
				tmpPkSent++;
				tmpsizeofpacket = tmpsizeofpacket + op_pk_total_size_get( pkptr );
				
				op_stat_local_write( Lsa_Vs_Other_Stat, ControlPktBitsSer/sizeofpacket );
				
				if( op_sim_time() > tmp_sim_time + 5*tracking_interval )
				{
					thru1 = tmpPkSent/5*tracking_interval;
					op_stat_local_write(THROUGHPUT, thru1);
					tmpPkSent = 0;
					tmp_sim_time = op_sim_time();
				
					thru3 = tmpsizeofpacket/5*tracking_interval;
					op_stat_local_write(BIT_THRU, thru3);
					tmpsizeofpacket = 0;
				}
				
				if(pkptr == OPC_NIL) 
					op_sim_end("Can't get any packet from que????","","","");
				
				
				/* 
				** An IP packet has completed service. Obtain the destination network and node numbers. 
				*/
				op_pk_nfd_get( pkptr, "dest_node", &dest_node );
				op_pk_nfd_get( pkptr, "dest_net", &dest_net );
				op_pk_nfd_get( pkptr, "src_net", &s_net );
				op_pk_nfd_get( pkptr, "src_node", &s_node );
				op_pk_nfd_get( pkptr, "prot_id",&protocol );
				op_pk_nfd_get( pkptr, "strm", &in_strm );
				SourceNet = s_net;
				GrpId = dest_node;
				
				VL  IPVL{    
				printf("(%d.%d) Got the Packet from %d.%d. The Packet Dest Address is %d.%d", net_num0,node_num0,s_net,s_node,dest_net, dest_node); 
				printf(" Rte_tab[%d]=%d  DEF_STRM=%d\n",dest_net,rte_tab[dest_net],rte_tab[DEF_STREAM]);
				}
				
				if ( op_sim_time() > tmp_sim_time1 + 5*tracking_interval )
				{
					FILE* fp;
					int track_flag;
				
				TRACE	printf("Current Simulation time is %f\n", op_sim_time() );
				 
					
					tmp_sim_time1 = op_sim_time();
				
					fp = fopen("../LogFiles/TurnOffFile", "r" );
					if(!fp)
						op_sim_end("Unable to open the file TurnOffFile......","","","");
					fscanf( fp, "%d", &track_flag );
					fclose( fp );
					if(!track_flag)
					{
						op_sim_end("Simulation stopped by the TurnOff file......","","","");
					}
				}
				
				if( protocol == IGMP_PROTOCOL_ID ) 
				{
					UP = 0;
				}
				
				if(dest_net == IS_MULTICAST )
				{ 
				 
					/*does this include data packets*/
					UP = 1;
					if( in_strm == IGMP_STREAM || in_strm == RSVP_STREAM || in_strm == QOSPF_STREAM || 
					  ( in_strm == 0 && dest_node == IS_MULTICAST) ) 
					{
						UP = 0; 			/* then it is a query or a response from this router */
					}
					else
					{
				    	/*
						** it's either a data from outside(2), or response to my query(3), or a query from 
						** another router(4)
						*/
				     	if( protocol == UDP_PROTOCOL_ID ) 
							UP = 0;
					}
				
					/* 
					** If the packet is a multicast data packet then check if it is requesting resources or
					** not. If it is resource requesting traffic send a remote interrupt to QOSPF module to
					** do  the qospf  dijikstra's calculation. If  the packet is best effort multicast data 
					** packet send remote  interrupt to QOSPF  module for the mospf dijikstra's calculation
					*/
					if( protocol == UDP_PROTOCOL_ID )
				    {
				        int IsResvPkt;
				        IsResvPkt = CheckIfResvPkt( s_net, s_node, dest_net, dest_node );
				        if( IsResvPkt == 0 )
						{
				/*            		op_intrpt_schedule_remote( op_sim_time(), 7, qospf_objid );   commented by Jiemei*/
							if ( mc_table[GrpId].infValid != s_net )	  /* Added by DG, 11/8 */
							{
								VL IPVL printf( "!!!!Recompute\n" );
								op_intrpt_force_remote( 7, qospf_objid ); /* Added by DG, 10/30 */
							}
							else
								VL IPVL printf( "Do not recompute!\n" );
						}
				        if( IsResvPkt == 1 )
						{
								VL IPVL printf( "\n!!!! Qospf Tree Calc IP begin, inStrm %d Prot %d\n", 
										in_strm, protocol );
							op_intrpt_force_remote( 8, qospf_objid );
								VL IPVL printf( "!!!! Qospf Tree Calc IP end\n" );
						}
				    }
				}
				if( protocol == QOSPF_PROTOCOL_ID && in_strm != QOSPF_STREAM )
				{
					VL IPVL printf( "Obtained a QOSPF Packet from the source %d through the stream %d\n",
							 s_net, in_strm );
					UP = 1;
				}
				if( protocol == RSVP_PROTOCOL_ID && in_strm !=RSVP_STREAM ) 
				{
					VL IPVL printf("IP LAYER(%d.%d): Obtained a packet from source %d.%d through stream %d\n", 
						net_num0, node_num0, s_net, s_node, in_strm );
					UP = 1;
				}
				
				/*
				** If there is no default route and no route to this packet and the packet neither a multicast
				** nor a OSPF control packet, then destroy the packet
				*/
				
				
				/* Add by DG, 9/26/97, to avoid duplicate UAPP packet whose source is in the same net, H1->H0. */
				if ( s_net == dest_net && dest_net != net_num0 )
				{
				    op_pk_destroy(pkptr);
				}
				else {
				
				if( rte_tab[dest_net] == -1 && rte_tab[DEF_STREAM] == -1 && dest_net != IS_MULTICAST && 
				    (dest_net !=ALL_SPF_ROUTER_NET && dest_node !=ALL_SPF_ROUTER_NODE) &&
					(dest_net !=ALL_D_ROUTER_NET && dest_node !=4) )
				{
				TRACE printf( "(%d.%d) Destroying pk from (%d.%d) destinated to (%d.%d) b'cos no route in svc_compl\n", 
							net_num0, node_num0, s_net, s_node, dest_net,dest_node );
				
					/*added by Jiemei*/
					total_destroy++;
				        op_stat_local_write(TOTAL_DESTROY_STAT,total_destroy);
				
					/*no_route_destroy++;
					TRACE printf("(%d.%d) no route destory=%d\n",net_num0,node_num0,no_route_destroy);
					*/
					op_pk_destroy( pkptr );
				}
				else
				{
					/* 
					** In the case of packets which have reached their destination, reassembly the ip fragments 
					*/
					if( (dest_net == net_num0 && dest_node == node_num0) ||
						(dest_net == net_num1 && dest_node == node_num1) ||
						(dest_net == net_num2 && dest_node == node_num2) ||
						(dest_net == net_num3 && dest_node == node_num3) ||
						(dest_net == net_num4 && dest_node == node_num4) || UP )
					{
						/* 
						** Call the fragment reassembly procedure to determine if a complete packet has arrived. 
						** Note that the packet will be destroyed in this procedure call unless it is itself the 
						** complete datagram (i.e., it isn't a fragment) 
						*/
						if( (ip_pkptr = ip_frag_sup_insert (dgram_list_ptr, pkptr)) != OPC_NIL )
						{
							if( protocol == IGMP_PROTOCOL_ID )
								outstrm= IGMP_STREAM;
							if( protocol == QOSPF_PROTOCOL_ID )
								outstrm = QOSPF_STREAM;         
							if( protocol == TCP_PROTOCOL_ID ) 
								outstrm = TCP_STREAM;
							if( protocol == RSVP_PROTOCOL_ID )
								outstrm = RSVP_STREAM;
				
				VL IPVL printf("GWY IP local outstrm=%d\n",outstrm);
							op_pk_send( ip_pkptr, outstrm ); /* Forward the complete packet to the higher layer. */
						}
					}
				
					/* 
					** For packets which have not reached their ultimate destination, they are forwarded to next hop. 
					*/
					else
					{   
						/* 
						** Decrement the packet's time-to-live field. If zero is reached, destroy the packet 
						*/
						op_pk_nfd_get( pkptr, "ttl", &ttl );
						ttl--;
						if( ttl == 0  && dest_net == IS_MULTICAST )
						{
							TRACE printf("(%d.%d) Destroy packet from(%d.%d) to (%d.%d) due to an expired ttl\n",net_num0,node_num0,s_net,s_node,dest_net,dest_node);               /*added by Jiemei*/
							total_destroy++;
							op_stat_local_write(TOTAL_DESTROY_STAT,total_destroy);
					
							op_pk_destroy (pkptr); 			/* due to an expired ttl. */
						}
						else
						{
							/* 
							** 
							*/
							op25_pk_nfd_set (pkptr, "ttl", ttl);       /*Assign the new decremented value of ttl.  */
				
							if( dest_net != IS_MULTICAST && 
								(dest_net!=ALL_SPF_ROUTER_NET && dest_node!=ALL_SPF_ROUTER_NODE) 
								|| protocol == RSVP_PROTOCOL_ID )
							{             
								if( protocol == RSVP_PROTOCOL_ID )
								{
									op_pk_nfd_get( pkptr, "outstrm", &outstrm );
				
									if( outstrm == -1 && Indep_Rou)
											outstrm++;
									else if( outstrm == -1 )
										outstrm = rte_tab[dest_net];
				
									VL IPVL printf("IP LAYER(%d.%d): Processing RSVP Packets, OUT STREAM is %d\n", 
											   net_num0, node_num0, outstrm );
								}
								else 
									outstrm = rte_tab[dest_net];
				
								if(outstrm == -1)
									outstrm = rte_tab[DEF_STREAM];
				
								mtu = 4096;
				
								/* 
								** Install an Ici indicating to the lower layer what the address of the next 
								** (intermediate) node is. 
								*/
								if(dest_net == 500)
									next_node = dest_net + dest_node;
								else
									next_node = dest_node;
								op_ici_attr_set( arp_iciptr, "next_node", next_node );
								op_ici_install( arp_iciptr );
								
								frag_size = op_pk_total_size_get( pkptr )/8;    /* size of the fragment in bytes       */
								op_pk_nfd_get( pkptr, "frag_len", &data_size ); /* Size of the data in fragment(bytes) */
								header_size = frag_size - data_size; /* Size of header(Diff btn. packet size & length) */
				
				VL IPVL printf("Forward outstrm=%d ID = %d\n",outstrm, op_pk_id(pkptr) );
				
								/* 
								** If it is smaller than the maximum transfer unit, send it as is. 
								*/
								if( frag_size <= mtu )
								{
									PROBE_ON
									{
				/* Added by DG and Jiemei, 11/27, 
				 Caculate traffic to the network, outstrm > 0
				*/
										if ( outstrm && ( s_net == net_num0 ) )
										{
											double load;
				
											TraftoNet = TraftoNet + op_pk_total_size_get( pkptr );
											TrafperSec =  TrafperSec +op_pk_total_size_get(pkptr );
											load = TraftoNet / op_sim_time() / CAPACITY;
											op_stat_local_write(TRAFFIC_LOAD, load );
										}
									}
									op_pk_send( pkptr, outstrm );
								}
								else
								{			
									/* 
									** Otherwise, break it into fragments. Each fragment can contain up to 
									** (mtu - header_size) bytes of data 
									*/
									num_frags = (data_size + mtu - header_size - 1) / (mtu - header_size);
				
									/* In debug mode, indicate the fragmentation. */
									if( op_prg_odb_ltrace_active ("ip_frag") )
									{
										sprintf( str0, "Breaking datagram into (%d) fragments", num_frags );
										op_prg_odb_print_major( str0, OPC_NIL );
									}
				
									/* 
									** If the fragment is carrying the original datagram given to IP, extract it 
									** before  copies are made. Only one fragment  can carry the original packet 
									** for the reassembly model to work properly. 
									*/
									if( op_pk_nfd_is_set (pkptr, "ip_dgram") )
										op_pk_nfd_get( pkptr, "ip_dgram", &ip_pkptr );
									else 
										ip_pkptr = OPC_NIL;
				
									/* 
									** If the packet is carrying any encapsulated data (normally this would happen 
									** only for a packet fragmented for  the first time), extract this data packet 
									** so that it will not appear in each fragment generated by copying. 
									*/
									if( op_pk_nfd_is_set( pkptr, "data" ) )
										op_pk_nfd_get( pkptr, "data", &data_pkptr );
									else data_pkptr = OPC_NIL;
				
									for( frag_accum = 0, i = 0; i < num_frags; i++ )   /* create the fragments.       */
									{
										frag_ptr = op_pk_copy( pkptr );       /* Make a copy of the original packet.  */
										op25_pk_nfd_set( frag_ptr, "frag", 1 ); /* Indicate that the copy is a fragment */
				
										/* 
										** for all but the last fragment, the size is the mtu. And the encapsulated 
										** ip packet is not included. 
										*/
										if( i < num_frags - 1 )
										{
											op25_pk_nfd_set( frag_ptr, "frag_len", mtu - header_size );
											op_pk_total_size_set( frag_ptr, 8 * mtu );
											frag_accum += (mtu - header_size);  
										}
										else
										{
											len = data_size - frag_accum;
											op25_pk_nfd_set( frag_ptr, "frag_len", len );
											op_pk_total_size_set( frag_ptr,	8 * (header_size + len) );
				
											/* 
											** If the original packet was not a fragment, encapsulate it into the last 
											** fragment created here. 
											*/
											op_pk_nfd_get( pkptr, "frag", &frag );
											if( !frag )
											{
												/* 
												** If the packet  contained encapsulated data (i.e., from the transport), 
												** that  data will  have been  removed  to avoid it's  duplication in the 
												** fragments. The data  should now be reinserted into the original packet 
												*/
												if( data_pkptr != OPC_NIL )
													op25_pk_nfd_set( pkptr, "data", data_pkptr );
				
												/* In either case the original packet is encapsulated in the fragment. */
												op25_pk_nfd_set( frag_ptr, "ip_dgram", pkptr ); 
											}
											else
											{
												op_pk_destroy (pkptr);
				
												/* 
												** Also, if  the packet includes the  original datagram from which it was 
												** generated, transfer that datagram into the last fragment created here. 
												** Note that it is possible, in the case where a fragment is itself being 
												** fragmented, none  of the created  fragments will  contain the original 
												** datagram. 
												*/
												if( ip_pkptr != OPC_NIL )
													op25_pk_nfd_set (frag_ptr, "ip_dgram", ip_pkptr);
											}
										}
				
										PROBE_ON
										{
				/* Added by DG and Jiemei, 11/27, 
				 Caculate traffic to the network, outstrm > 0
				*/
											if ( outstrm && ( s_net == net_num0 ) )
											{
												double load;
					
												TraftoNet = TraftoNet + op_pk_total_size_get( frag_ptr );
												TrafperSec =  TrafperSec +op_pk_total_size_get(pkptr );
												load = TraftoNet / op_sim_time() / CAPACITY;
												op_stat_local_write(TRAFFIC_LOAD, load );
											}
										}
										op_pk_send (frag_ptr, outstrm);			/* Forward the datagram fragment. */
									}	
								}
							}  
							else		/* if multicast */
							{
								if(gwy_type)
								{
									VL IPVL	printf("Gwy_type is %d\n, and In Stream is %d, NoOfLinks are %d\n", 
												gwy_type, in_strm, n_links );
									if( (in_strm == 0 && protocol == UDP_PROTOCOL_ID)|| protocol == QOSPF_PROTOCOL_ID
										|| protocol == RSVP_PROTOCOL_ID )
										op = 1;
									else 
										op = 0;
								}
								else
									op = 1;  /*start at 1 because fddi interface=0 */
				
								VL IPVL printf("IP LAYER, op = %d", op );
								VL	IPVL
								{
									int i, j;
									printf(" %d.%d IP Layer MC_TABLE : \n", net_num0, node_num0 );
									printf(" - - - - - - - - - - - - - \n");
									for ( i = 0; i < MAX_NO_GRPS; i++ )
										for(j = 0; j <= n_links; j++ )
											if( mc_table[i].interface[j] == 1 )
												printf(" Interface %d is registered for the Group %d \n", j, i );
								}
				
								if( (dest_net == IS_MULTICAST || 
									(dest_net == ALL_SPF_ROUTER_NET && dest_node == ALL_SPF_ROUTER_NODE)) &&
									protocol != RSVP_PROTOCOL_ID )
								{  
									ip_pkptr = op_pk_copy(pkptr);   
									op_pk_destroy(pkptr);
									while( op < n_links+1 ) /* Goes to n_links+1 because link number start at 1 */ 
									{ 
										
										if(dest_node != 500)
										{
											VL IPVL printf("link[%d] = %d\n",op,mc_table[dest_node].interface[op]);
											/*getchar();*/
										}
									
										if( ((mc_table[dest_node].interface[op] == 1  && dest_net == IS_MULTICAST) || 
											 (dest_net == ALL_SPF_ROUTER_NET && dest_node == ALL_SPF_ROUTER_NODE)) && 
											(op != in_strm) )
										{      
											mtu = 4096; 
											VL IPVL printf("Sending on link : %d at (%d.%d)\n",op,net_num0,node_num0);
				
											pkptr = op_pk_copy(ip_pkptr);
											if(op == 0) 
											/*means it's going to ethernet*/
											{  
												next_node = 500+dest_node;
												op_ici_attr_set(arp_iciptr,"next_node",next_node);
												op_ici_install(arp_iciptr);
											}
				
											/*
											** sending the pk
											*/
											frag_size = op_pk_total_size_get (pkptr) / 8; /* Size of fragment in bytes */
											op_pk_nfd_get( pkptr, "frag_len", &data_size ); /* Size of data in bytes   */
											header_size = frag_size - data_size; 			/* Header size in bytes    */
				
											/* 
											** If fragment is  smaller than the maximum transfer unit, send it as is. 
											*/
											if (frag_size <= mtu)
											{ 
												PROBE_ON
												{
				/* Added by DG and Jiemei, 11/27, 
				   Caculate traffic to the network, outstrm > 0
				*/
												if ( outstrm && ( s_net == net_num0 ) )
													{
													double load;
						
													TraftoNet = TraftoNet + op_pk_total_size_get( pkptr );
													TrafperSec =  TrafperSec +op_pk_total_size_get(pkptr );
													load = TraftoNet / op_sim_time() / CAPACITY;
													op_stat_local_write(TRAFFIC_LOAD, load );
													}
												}
												op_pk_send( pkptr, op );
											}
											else
											{			
												/* 
												** Otherwise, break it into fragments. Each fragment can contain up to 
												** (mtu - header_size) bytes of data 
												*/
												num_frags = (data_size + mtu - header_size - 1) / (mtu - header_size);
				
												/* In debug mode, indicate the fragmentation. */
												if( op_prg_odb_ltrace_active ("ip_frag") )
												{
													sprintf( str0, "Breaking datagram into (%d) fragments", num_frags );
													op_prg_odb_print_major( str0, OPC_NIL );
												}
				
												/* 
												** If the fragment is carrying the original datagram given to IP, extract 
												** it  before copies are made. Only  one fragment can  carry the original 
												** packet for the reassembly model to work properly. 
												*/
												if( op_pk_nfd_is_set (pkptr, "ip_dgram") )
													op_pk_nfd_get( pkptr, "ip_dgram", &ip_pkptr );
												else 
													ip_pkptr = OPC_NIL;
				
												/* 
												** If the packet is carrying encapsulated data (normally this would happen 
												** only  for a packet  fragmented for the first time ), extract  this data 
												** packet so that it will not appear in each fragment generated by copying. 
												*/
												if( op_pk_nfd_is_set( pkptr, "data" ) )
													op_pk_nfd_get (pkptr, "data", &data_pkptr);
												else 
													data_pkptr = OPC_NIL;
				
												for( frag_accum = 0, i = 0; i < num_frags; i++ ) /* Create the fragments */
												{
													frag_ptr = op_pk_copy (pkptr);  /* Copy the original packet          */
													op25_pk_nfd_set (frag_ptr, "frag", 1); /* Indicate that it is fragment */
				
													/* 
													** for all but the last fragment, the size is the mtu. And the 
													** encapsulated ip packet is not included. 
													*/
													if( i < num_frags - 1 )
													{
														op25_pk_nfd_set( frag_ptr, "frag_len", mtu - header_size );
														op_pk_total_size_set( frag_ptr, 8 * mtu );
														frag_accum += (mtu - header_size);  
													}
													else
													{
														len = data_size - frag_accum;
														op25_pk_nfd_set( frag_ptr, "frag_len", len );
														op_pk_total_size_set( frag_ptr,	8 * (header_size + len) );
														/* 
														** If the original packet was not a fragment, encapsulate it 
														** into the last fragment created here. 
														*/
														op_pk_nfd_get( pkptr, "frag", &frag );
														if( !frag )
														{
															/* 
															** If the packet contained encapsulated data(i.e., from the 
															** transport ), that data  will have been  removed to avoid 
															** its duplication in the fragments. The data should now be 
															** reinserted into the original packet. 
															*/
															if( data_pkptr != OPC_NIL )
																op25_pk_nfd_set( pkptr, "data", data_pkptr );
				
															/* 
															** In either case the original packet is encapsulated in the 
															** fragment. 
															*/
															op25_pk_nfd_set( frag_ptr, "ip_dgram", pkptr );
														}
				
														/* 
														** Otherwise the packet can be discarded. 
														*/
														else
														{
															op_pk_destroy( pkptr );
				
															/* 
															** Also, if  the packet includes  the  original  datagram from 
															** which it was  generated, transfer  that datagram  into  the 
															** last  fragment created  here. Note that  it is possible, in 
															** the case where a fragment is  itself being fragmented, none 
															** of the created fragments will contain the original datagram
															*/
															if( ip_pkptr != OPC_NIL )
																op25_pk_nfd_set (frag_ptr, "ip_dgram", ip_pkptr);
														}
													}
				
													PROBE_ON
													{
				/* Added by DG and Jiemei, 11/27, 
				   Caculate traffic to the network, outstrm > 0
				*/
													if ( outstrm && ( s_net == net_num0 ) )
														{
														double load;
						
														TraftoNet = TraftoNet + op_pk_total_size_get( frag_ptr );
														TrafperSec =  TrafperSec +op_pk_total_size_get(pkptr );
														load = TraftoNet / op_sim_time() / CAPACITY;
														op_stat_local_write(TRAFFIC_LOAD, load );
														}
													}
				
													op_pk_send( frag_ptr, op );     /* Forward the datagram fragment. */
												}	
											}
										}
										op++;
									}
									op_pk_destroy(ip_pkptr);
								}
							}
						}
					}
				}
				}
				server_busy = IDLE;                                 /* The IP routing server becomes available again. */
				}


			/** state (svc_compl) exit executives **/
			FSM_STATE_EXIT_FORCED (4, state4_exit_exec, "svc_compl", "ip_gwy () [svc_compl exit execs]")
				{
				
				}


			/** state (svc_compl) transition processing **/
			FSM_INIT_COND (!QUEUE_EMPTY)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("svc_compl")

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 3, state3_enter_exec, ;)
				FSM_CASE_TRANSIT (1, 2, state2_enter_exec, ;)
				}
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (0,ip_gwy)
		}
	}

extern
#if defined (__cplusplus)
	"C"
#endif
	void Vos_Vnop (void);


Compcode
ip_gwy_init (void ** gen_state_pptr)
	{
	int _block_origin = 0;
	static VosT_Cm_Obtype	obtype = OPC_NIL;

	FIN (ip_gwy_init (gen_state_pptr))

	if (obtype == OPC_NIL)
		{
		/* Initialize memory management */
		if (Vos_Catmem_Register ("proc state vars (ip_gwy)",
			sizeof (ip_gwy_state), Vos_Vnop, &obtype) == VOSC_FAILURE)
			{
			FRET (OPC_COMPCODE_FAILURE)
			}
		}

	*gen_state_pptr = Vos_Catmem_Alloc (obtype, 1);
	if (*gen_state_pptr == OPC_NIL)
		{
		FRET (OPC_COMPCODE_FAILURE)
		}
	else
		{
		/* Initialize FSM handling */
		((ip_gwy_state *)(*gen_state_pptr))->current_block = 0;

		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



void
ip_gwy_diag (void)
	{
	int _block_origin = __LINE__;

	FIN (ip_gwy_diag ())

	if (1)
		{
		Objid		dup_lk_id;
		double          thru, thru1, thru2, thru3, pk_svc_time;
		int             insert_ok;
		int				outstrm, mtu, frag,resp,op,UP;
		int				next_net, next_node;
		int				dest_net, dest_node,s_net,s_node,protocol;
		int				i,j,frag_accum, num_frags;
		int				frag_size, data_size, len,data_len;
		int				header_size, ttl;
		char			str0 [512], str1 [512];
		Packet			*pkptr, *ip_pkptr, *frag_ptr;
		Packet			*data_pkptr;
		
		int 			  term,join,grp_id,in_strm,join_pk;
		

		/* Diagnostic Block */


		BINIT
		op_prg_odb_print_major ("State of Reassembly Table:", OPC_NIL);
		ip_frag_sup_print (dgram_list_ptr);
		

		/* End of Diagnostic Block */

		}

	FOUT;
	}




void
ip_gwy_terminate (void)
	{
	int _block_origin = __LINE__;

	FIN (ip_gwy_terminate (void))

	if (1)
		{
		Objid		dup_lk_id;
		double          thru, thru1, thru2, thru3, pk_svc_time;
		int             insert_ok;
		int				outstrm, mtu, frag,resp,op,UP;
		int				next_net, next_node;
		int				dest_net, dest_node,s_net,s_node,protocol;
		int				i,j,frag_accum, num_frags;
		int				frag_size, data_size, len,data_len;
		int				header_size, ttl;
		char			str0 [512], str1 [512];
		Packet			*pkptr, *ip_pkptr, *frag_ptr;
		Packet			*data_pkptr;
		
		int 			  term,join,grp_id,in_strm,join_pk;
		

		/* No Termination Block */

		}
	Vos_Catmem_Dealloc (pr_state_ptr);

	FOUT;
	}


/* Undefine shortcuts to state variables to avoid */
/* syntax error in direct access to fields of */
/* local variable prs_ptr in ip_gwy_svar function. */
#undef server_busy
#undef rte_tab
#undef gwy_type
#undef Indep_Rou
#undef mc_join
#undef pk_sent
#undef tmpPkSent
#undef sizeofpacket
#undef tmpsizeofpacket
#undef service_rate
#undef tmp_sim_time
#undef tmp_sim_time1
#undef tracking_interval
#undef ControlPktBitsSer
#undef own_id
#undef sub_netid
#undef qospf_objid
#undef rsvp_objid
#undef net_num0
#undef node_num0
#undef net_num1
#undef node_num1
#undef net_num2
#undef node_num2
#undef net_num3
#undef node_num3
#undef net_num4
#undef node_num4
#undef net_num5
#undef node_num5
#undef net_num6
#undef node_num6
#undef net_num7
#undef node_num7
#undef net_num8
#undef node_num8
#undef net_num9
#undef node_num9
#undef arp_iciptr
#undef dgram_list_ptr
#undef def_str
#undef default_ttl
#undef n_links
#undef mc_table
#undef print_flag
#undef control_pk_queue
#undef resv_pk_queue
#undef be_pk_queue
#undef SourceNet
#undef GrpId
#undef TraftoNet
#undef TrafperSec
#undef lastTrafTime
#undef sec_node_ctrl_overflow
#undef sec_node_be_overflow
#undef sec_node_resv_overflow
#undef node_ctrl_overflow
#undef node_be_overflow
#undef node_resv_overflow
#undef RawTraftoNet
#undef RawTrafperSec



void
ip_gwy_svar (void * gen_ptr, const char * var_name, char ** var_p_ptr)
	{
	ip_gwy_state		*prs_ptr;

	FIN (ip_gwy_svar (gen_ptr, var_name, var_p_ptr))

	*var_p_ptr = (char *)VOS_NIL;
	prs_ptr = (ip_gwy_state *)gen_ptr;

	if (Vos_String_Equal ("server_busy" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->server_busy);
		goto func_return;
		}
	if (Vos_String_Equal ("rte_tab" , var_name))
		{
		*var_p_ptr = (char *) (prs_ptr->rte_tab);
		goto func_return;
		}
	if (Vos_String_Equal ("gwy_type" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->gwy_type);
		goto func_return;
		}
	if (Vos_String_Equal ("Indep_Rou" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->Indep_Rou);
		goto func_return;
		}
	if (Vos_String_Equal ("mc_join" , var_name))
		{
		*var_p_ptr = (char *) (prs_ptr->mc_join);
		goto func_return;
		}
	if (Vos_String_Equal ("pk_sent" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->pk_sent);
		goto func_return;
		}
	if (Vos_String_Equal ("tmpPkSent" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->tmpPkSent);
		goto func_return;
		}
	if (Vos_String_Equal ("sizeofpacket" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->sizeofpacket);
		goto func_return;
		}
	if (Vos_String_Equal ("tmpsizeofpacket" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->tmpsizeofpacket);
		goto func_return;
		}
	if (Vos_String_Equal ("service_rate" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->service_rate);
		goto func_return;
		}
	if (Vos_String_Equal ("tmp_sim_time" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->tmp_sim_time);
		goto func_return;
		}
	if (Vos_String_Equal ("tmp_sim_time1" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->tmp_sim_time1);
		goto func_return;
		}
	if (Vos_String_Equal ("tracking_interval" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->tracking_interval);
		goto func_return;
		}
	if (Vos_String_Equal ("ControlPktBitsSer" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->ControlPktBitsSer);
		goto func_return;
		}
	if (Vos_String_Equal ("own_id" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->own_id);
		goto func_return;
		}
	if (Vos_String_Equal ("sub_netid" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->sub_netid);
		goto func_return;
		}
	if (Vos_String_Equal ("qospf_objid" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->qospf_objid);
		goto func_return;
		}
	if (Vos_String_Equal ("rsvp_objid" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->rsvp_objid);
		goto func_return;
		}
	if (Vos_String_Equal ("net_num0" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->net_num0);
		goto func_return;
		}
	if (Vos_String_Equal ("node_num0" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->node_num0);
		goto func_return;
		}
	if (Vos_String_Equal ("net_num1" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->net_num1);
		goto func_return;
		}
	if (Vos_String_Equal ("node_num1" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->node_num1);
		goto func_return;
		}
	if (Vos_String_Equal ("net_num2" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->net_num2);
		goto func_return;
		}
	if (Vos_String_Equal ("node_num2" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->node_num2);
		goto func_return;
		}
	if (Vos_String_Equal ("net_num3" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->net_num3);
		goto func_return;
		}
	if (Vos_String_Equal ("node_num3" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->node_num3);
		goto func_return;
		}
	if (Vos_String_Equal ("net_num4" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->net_num4);
		goto func_return;
		}
	if (Vos_String_Equal ("node_num4" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->node_num4);
		goto func_return;
		}
	if (Vos_String_Equal ("net_num5" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->net_num5);
		goto func_return;
		}
	if (Vos_String_Equal ("node_num5" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->node_num5);
		goto func_return;
		}
	if (Vos_String_Equal ("net_num6" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->net_num6);
		goto func_return;
		}
	if (Vos_String_Equal ("node_num6" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->node_num6);
		goto func_return;
		}
	if (Vos_String_Equal ("net_num7" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->net_num7);
		goto func_return;
		}
	if (Vos_String_Equal ("node_num7" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->node_num7);
		goto func_return;
		}
	if (Vos_String_Equal ("net_num8" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->net_num8);
		goto func_return;
		}
	if (Vos_String_Equal ("node_num8" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->node_num8);
		goto func_return;
		}
	if (Vos_String_Equal ("net_num9" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->net_num9);
		goto func_return;
		}
	if (Vos_String_Equal ("node_num9" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->node_num9);
		goto func_return;
		}
	if (Vos_String_Equal ("arp_iciptr" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->arp_iciptr);
		goto func_return;
		}
	if (Vos_String_Equal ("dgram_list_ptr" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->dgram_list_ptr);
		goto func_return;
		}
	if (Vos_String_Equal ("def_str" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->def_str);
		goto func_return;
		}
	if (Vos_String_Equal ("default_ttl" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->default_ttl);
		goto func_return;
		}
	if (Vos_String_Equal ("n_links" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->n_links);
		goto func_return;
		}
	if (Vos_String_Equal ("mc_table" , var_name))
		{
		*var_p_ptr = (char *) (prs_ptr->mc_table);
		goto func_return;
		}
	if (Vos_String_Equal ("print_flag" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->print_flag);
		goto func_return;
		}
	if (Vos_String_Equal ("control_pk_queue" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->control_pk_queue);
		goto func_return;
		}
	if (Vos_String_Equal ("resv_pk_queue" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->resv_pk_queue);
		goto func_return;
		}
	if (Vos_String_Equal ("be_pk_queue" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->be_pk_queue);
		goto func_return;
		}
	if (Vos_String_Equal ("SourceNet" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->SourceNet);
		goto func_return;
		}
	if (Vos_String_Equal ("GrpId" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->GrpId);
		goto func_return;
		}
	if (Vos_String_Equal ("TraftoNet" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->TraftoNet);
		goto func_return;
		}
	if (Vos_String_Equal ("TrafperSec" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->TrafperSec);
		goto func_return;
		}
	if (Vos_String_Equal ("lastTrafTime" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->lastTrafTime);
		goto func_return;
		}
	if (Vos_String_Equal ("sec_node_ctrl_overflow" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->sec_node_ctrl_overflow);
		goto func_return;
		}
	if (Vos_String_Equal ("sec_node_be_overflow" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->sec_node_be_overflow);
		goto func_return;
		}
	if (Vos_String_Equal ("sec_node_resv_overflow" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->sec_node_resv_overflow);
		goto func_return;
		}
	if (Vos_String_Equal ("node_ctrl_overflow" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->node_ctrl_overflow);
		goto func_return;
		}
	if (Vos_String_Equal ("node_be_overflow" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->node_be_overflow);
		goto func_return;
		}
	if (Vos_String_Equal ("node_resv_overflow" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->node_resv_overflow);
		goto func_return;
		}
	if (Vos_String_Equal ("RawTraftoNet" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->RawTraftoNet);
		goto func_return;
		}
	if (Vos_String_Equal ("RawTrafperSec" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->RawTrafperSec);
		goto func_return;
		}

func_return:

	FOUT;
	}

