/* Process model C form file: ip_host_arp.pr.c */
/* Portions of this file copyright 1992, 1996, 1998 by MIL 3, Inc. */



/* This variable carries the header into the object file */
static const char ip_host_arp_pr_c [] = "MIL_3_Tfile_Hdr_ 60L 30A op_runsim 7 38FBBA83 38FBBA83 1 chrono.ite.gmu.edu vmukkama 0 0 none none 0 0 none 0 0 0 0 0 0";


/* OPNET system definitions */
#include <opnet.h>

#if defined (__cplusplus)
extern "C" {
#endif
FSM_EXT_DECS
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif


/* Header Block */

#define TRACE 	if(0)

#include "ip_arp_sup.h"
#include <sys/file.h>

typedef struct
{
	int			node_num;
	int			phys_addr;
} arp_entry;
                 

/* Transition Mnemonics */
#define ARRIVAL		op_intrpt_type () == OPC_INTRPT_STRM

/* identification constant for IP protocol within Ethernet frames */
#define NET_PROT_IP		0x800

#define MAC_STREAM      0

/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		_fstack_local_info.last_line_passed = __LINE__ - _block_origin;
#define	BOUT	BIN
#define	BINIT	_fstack_local_info.last_line_passed = 0; _block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	/* State Variables */
	arp_entry*	             		addr_table;
	int	                    		num_entries;
	char	                   		addr_file [512];
	Objid	                  		my_id;
	Ici*	                   		mac_iciptr;
	arp_table*	             		at_ptr;
	} ip_host_arp_state;

#define pr_state_ptr            		((ip_host_arp_state*) SimI_Mod_State_Ptr)
#define addr_table              		pr_state_ptr->addr_table
#define num_entries             		pr_state_ptr->num_entries
#define addr_file               		pr_state_ptr->addr_file
#define my_id                   		pr_state_ptr->my_id
#define mac_iciptr              		pr_state_ptr->mac_iciptr
#define at_ptr                  		pr_state_ptr->at_ptr

/* This macro definition will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE
#define FIN_PREAMBLE	ip_host_arp_state *op_sv_ptr = pr_state_ptr;


/* No Function Block */

enum { _block_origin = __LINE__ };

#if defined (__cplusplus)
extern "C" {
#endif
	void ip_host_arp (void);
	Compcode ip_host_arp_init (void **);
	void ip_host_arp_diag (void);
	void ip_host_arp_terminate (void);
	void ip_host_arp_svar (void *, const char *, char **);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
ip_host_arp (void)
	{
	int _block_origin = 0;
	FIN (ip_host_arp ());
	if (1)
		{
		int				instrm, next_node;
		char			str0 [512], str1 [512];
		Packet*			pkptr;
		Ici*			iciptr;
		int				phys_addr;
		int				status;
		char			error_string [512];


		FSM_ENTER (ip_host_arp)

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (INIT) enter executives **/
			FSM_STATE_ENTER_FORCED (0, state0_enter_exec, "INIT", "ip_host_arp () [INIT enter execs]")
				{
				/******************************************************************************************************
				** Process Model : ip_host_arp                                                                       **
				** State         : INIT                                                                              **
				** Authors       : Ravi Malghan (rmalghan@descartes.gmu.edu)                                         **
				**                                                                                                   **
				** This state loads the memory table that is specified in the configuration file into the memory and **
				** creates an ICI pointer to communicate with layer 2 (FDDI MAC Layer).                              **
				**                                                                                                   **
				******************************************************************************************************/
				
				my_id = op_id_self ();                /*       Obtain the object ID of the ARP processor.          */
				
				
				/*added by Jiemei*/
				TRACE	printf("HostArp: MyObjId %d",my_id);
				
				
				/* 
				** Obtain the name of the address conversion file to be used by this ARP processor. Load this address
				** file into the memory
				*/
				op_ima_obj_attr_get (my_id, "addr_file", addr_file);
				
				
				/*added by Jiemei*/
				TRACE printf("  addr_file %s\n",&addr_file);
				
				at_ptr = arp_sup_table_setup (addr_file);
				 
				mac_iciptr = op_ici_create ("ip_mac_req");           /* Create an Ici to communicate with layer 2. */
				}


			/** state (INIT) exit executives **/
			FSM_STATE_EXIT_FORCED (0, state0_exit_exec, "INIT", "ip_host_arp () [INIT exit execs]")
				{
				}


			/** state (INIT) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;)
				/*---------------------------------------------------------*/



			/** state (WAIT) enter executives **/
			FSM_STATE_ENTER_UNFORCED (1, state1_enter_exec, "WAIT", "ip_host_arp () [WAIT enter execs]")
				{
				
				}


			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (3,ip_host_arp)


			/** state (WAIT) exit executives **/
			FSM_STATE_EXIT_UNFORCED (1, state1_exit_exec, "WAIT", "ip_host_arp () [WAIT exit execs]")
				{
				}


			/** state (WAIT) transition processing **/
			FSM_TRANSIT_ONLY ((ARRIVAL), 2, state2_enter_exec, ;, "WAIT")
				/*---------------------------------------------------------*/



			/** state (ARRIVAL) enter executives **/
			FSM_STATE_ENTER_FORCED (2, state2_enter_exec, "ARRIVAL", "ip_host_arp () [ARRIVAL enter execs]")
				{
				/************************************************************************************************************
				** Process Model : ip_host_arp                                                                             **
				** State         : ARRIVAL                                                                                 **
				**                                                                                                         **
				** Transition to this state occurs when there is a packet arrival in the wait state. If no ICI is received **
				** that corresponds to this packet simulation is aborted. If there is an ICI, next node number is obtained **
				** from  the ICI and corresponding  physical address is  determined using the  address table loaded in the **
				** memory. If  the address translation is done, then  the destination address is  installed in the ICI and **
				** the ICI packet is sent to mac layer. This state on default transits to WAIT state.                      **
				**                                                                                                         **
				************************************************************************************************************/
				
				instrm = op_intrpt_strm();               /* Determine on which input stream the packet is arrived. */
				
				/* 
				** Obtain the packet and the accompanying ICI. If there is no such ICI end the simulation.
				*/
				pkptr = op_pk_get( instrm );
				iciptr = op_intrpt_ici();  
				if( iciptr == OPC_NIL )
				{
					sprintf( error_string, "Simulation aborted; error in object (%d)", op_id_self () );
					op_sim_end( error_string, "ip_arp: required ICI not received", " ", " " );
				}
				
				op_ici_attr_get( iciptr, "next_node", &next_node );           /* Obtain the next node number. */
				
				/* 
				** Determine the corresponding physical address. 
				*/
				status = arp_sup_phys_addr_get( at_ptr, next_node, &phys_addr );
				
				if( status == OPC_COMPCODE_FAILURE )
				{
					/* If the address translation failed, issue an error message. */
					sprintf( str0, "ARP: discarding unmappable packet (%d)", op_pk_id( pkptr ) );
					sprintf( str1, "node number: (%d)", next_node );
					op_pk_destroy( pkptr );
					op_sim_message( str0, str1 );	
				}
				else
				{	
					/* place the destination address and protocol type (IP) into the ICI */
					op_ici_attr_set( mac_iciptr, "dest_addr", phys_addr );
					op_ici_attr_set( mac_iciptr, "protocol_type", NET_PROT_IP );
				
					/* send the packet coupled with the ICI */
					op_ici_install( mac_iciptr );
					op_pk_send( pkptr, MAC_STREAM );
				}
				}


			/** state (ARRIVAL) exit executives **/
			FSM_STATE_EXIT_FORCED (2, state2_exit_exec, "ARRIVAL", "ip_host_arp () [ARRIVAL exit execs]")
				{
				}


			/** state (ARRIVAL) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;)
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (0,ip_host_arp)
		}
	}

extern
#if defined (__cplusplus)
	"C"
#endif
	void Vos_Vnop (void);


Compcode
ip_host_arp_init (void ** gen_state_pptr)
	{
	int _block_origin = 0;
	static VosT_Cm_Obtype	obtype = OPC_NIL;

	FIN (ip_host_arp_init (gen_state_pptr))

	if (obtype == OPC_NIL)
		{
		/* Initialize memory management */
		if (Vos_Catmem_Register ("proc state vars (ip_host_arp)",
			sizeof (ip_host_arp_state), Vos_Vnop, &obtype) == VOSC_FAILURE)
			{
			FRET (OPC_COMPCODE_FAILURE)
			}
		}

	*gen_state_pptr = Vos_Catmem_Alloc (obtype, 1);
	if (*gen_state_pptr == OPC_NIL)
		{
		FRET (OPC_COMPCODE_FAILURE)
		}
	else
		{
		/* Initialize FSM handling */
		((ip_host_arp_state *)(*gen_state_pptr))->current_block = 0;

		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



void
ip_host_arp_diag (void)
	{
	/* No Diagnostic Block */
	}




void
ip_host_arp_terminate (void)
	{
	int _block_origin = __LINE__;

	FIN (ip_host_arp_terminate (void))

	if (1)
		{
		int				instrm, next_node;
		char			str0 [512], str1 [512];
		Packet*			pkptr;
		Ici*			iciptr;
		int				phys_addr;
		int				status;
		char			error_string [512];

		/* No Termination Block */

		}
	Vos_Catmem_Dealloc (pr_state_ptr);

	FOUT;
	}


/* Undefine shortcuts to state variables to avoid */
/* syntax error in direct access to fields of */
/* local variable prs_ptr in ip_host_arp_svar function. */
#undef addr_table
#undef num_entries
#undef addr_file
#undef my_id
#undef mac_iciptr
#undef at_ptr



void
ip_host_arp_svar (void * gen_ptr, const char * var_name, char ** var_p_ptr)
	{
	ip_host_arp_state		*prs_ptr;

	FIN (ip_host_arp_svar (gen_ptr, var_name, var_p_ptr))

	*var_p_ptr = (char *)VOS_NIL;
	prs_ptr = (ip_host_arp_state *)gen_ptr;

	if (Vos_String_Equal ("addr_table" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->addr_table);
		goto func_return;
		}
	if (Vos_String_Equal ("num_entries" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->num_entries);
		goto func_return;
		}
	if (Vos_String_Equal ("addr_file" , var_name))
		{
		*var_p_ptr = (char *) (prs_ptr->addr_file);
		goto func_return;
		}
	if (Vos_String_Equal ("my_id" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->my_id);
		goto func_return;
		}
	if (Vos_String_Equal ("mac_iciptr" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->mac_iciptr);
		goto func_return;
		}
	if (Vos_String_Equal ("at_ptr" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->at_ptr);
		goto func_return;
		}

func_return:

	FOUT;
	}

