/* Process model C form file: mapp.pr.c */
/* Portions of this file copyright 1992, 1996, 1998 by MIL 3, Inc. */



/* This variable carries the header into the object file */
static const char mapp_pr_c [] = "MIL_3_Tfile_Hdr_ 60L 30A op_runsim 7 38FBBA8B 38FBBA8B 1 chrono.ite.gmu.edu vmukkama 0 0 none none 0 0 none 0 0 0 0 0 0";


/* OPNET system definitions */
#include <opnet.h>

#if defined (__cplusplus)
extern "C" {
#endif
FSM_EXT_DECS
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif


/* Header Block */

#define TRACE 	if(0)

/*
** Define the conditions for transitions to different states in the process
*/
#define	PK_ARR	op_intrpt_type () == OPC_INTRPT_STRM
#define	SELF_INT0	(op_intrpt_type () == OPC_INTRPT_SELF  && op_intrpt_code () == 0)
#define	SELF_INT1	(op_intrpt_type () == OPC_INTRPT_SELF  && op_intrpt_code () == 1)
#define END_SIM		op_intrpt_type () ==  OPC_INTRPT_ENDSIM

/*
** Probe that is used to send the data packets sent by this module (or application or process)
*/
#define CUMM_MAPP_PKT_SENT_STAT	0

#define join_term_intr  0
#define send_data_intr  1

#define JOIN_TRUE       1
#define JOIN_FALSE      0
#define TERM_TRUE       1
#define TERM_FALSE      0

#define ON				1
#define OFF				0

#define VL			if(ON)
#define MADL			if(OFF)

#define PROBE_ON		if(ON)
#define PROBE_OFF		if(OFF)

#define IGMP_STREAM		0
#define IP_STREAM		1

#define UDP_PROTOCOL_ID	20

typedef struct 
{
	char Message[500];
}App_Data;

typedef struct
{
	int NetNum;
	int NodeNum;
}IPAddress;

double NoOfMappPktsSent;

/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		_fstack_local_info.last_line_passed = __LINE__ - _block_origin;
#define	BOUT	BIN
#define	BINIT	_fstack_local_info.last_line_passed = 0; _block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	/* State Variables */
	Objid	                  		my_objid;
	Objid	                  		ip_objid;
	double	                 		tim;
	double	                 		sessmin;
	double	                 		sessmax;
	double	                 		data_iat;
	double	                 		sess_iat;
	int                     		InitJoinTime;
	int                     		dest_net;
	int                     		dest_node;
	int                     		data_len;
	int                     		grp_id;
	int                     		sess;
	int                     		ngrps;
	Distribution*           		grp_dist;
	Distribution*           		time_dist;
	Distribution*           		term_dist;
	IPAddress               		LocalAddress;
	} mapp_state;

#define pr_state_ptr            		((mapp_state*) SimI_Mod_State_Ptr)
#define my_objid                		pr_state_ptr->my_objid
#define ip_objid                		pr_state_ptr->ip_objid
#define tim                     		pr_state_ptr->tim
#define sessmin                 		pr_state_ptr->sessmin
#define sessmax                 		pr_state_ptr->sessmax
#define data_iat                		pr_state_ptr->data_iat
#define sess_iat                		pr_state_ptr->sess_iat
#define InitJoinTime            		pr_state_ptr->InitJoinTime
#define dest_net                		pr_state_ptr->dest_net
#define dest_node               		pr_state_ptr->dest_node
#define data_len                		pr_state_ptr->data_len
#define grp_id                  		pr_state_ptr->grp_id
#define sess                    		pr_state_ptr->sess
#define ngrps                   		pr_state_ptr->ngrps
#define grp_dist                		pr_state_ptr->grp_dist
#define time_dist               		pr_state_ptr->time_dist
#define term_dist               		pr_state_ptr->term_dist
#define LocalAddress            		pr_state_ptr->LocalAddress

/* This macro definition will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE
#define FIN_PREAMBLE	mapp_state *op_sv_ptr = pr_state_ptr;


/* No Function Block */

enum { _block_origin = __LINE__ };

#if defined (__cplusplus)
extern "C" {
#endif
	void mapp (void);
	Compcode mapp_init (void **);
	void mapp_diag (void);
	void mapp_terminate (void);
	void mapp_svar (void *, const char *, char **);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
mapp (void)
	{
	int _block_origin = 0;
	FIN (mapp ());
	if (1)
		{
		Packet*  pkptr;
		int in_strm,da1,da2,da3;
		FILE*  fil;
		


		FSM_ENTER (mapp)

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (init) enter executives **/
			FSM_STATE_ENTER_FORCED (0, state0_enter_exec, "init", "mapp () [init enter execs]")
				{
				/***********************************************************************************************
				** Process Model : mapp (Multicast traffic generating application)                            **
				** State         : init                                                                       **
				** Authors       : Lava K Lavu(llavu@nac.gmu.edu) & Ravi Malghan(rmalghan@descartes.gmu.edu)  **
				**                                                                                            **
				** This block intializes all the variables that are used throughout this process model, loads **
				** the distribution that are used to select the destination  multicast group of the data, the **
				** duration of each multicast  session and time interval at which it registers for a session. **
				** It also schedules a interrupt for sending data packets.                                    **
				**                                                                                            **
				***********************************************************************************************/
				
				/*
				** Get the present module's object id and load all the attributes from the configuration file
				*/
				my_objid = op_id_self();
				
				op_ima_obj_attr_get( my_objid, "NGRPS", &ngrps );
				op_ima_obj_attr_get( my_objid, "SESSMIN", &sessmin );
				op_ima_obj_attr_get( my_objid, "SESSMAX", &sessmax );
				op_ima_obj_attr_get( my_objid, "DATA_IAT", &data_iat );
				op_ima_obj_attr_get( my_objid, "SESS_IAT", &sess_iat );
				op_ima_obj_attr_get( my_objid, "InitTime", &InitJoinTime );
				
				/*added by Jiemie*/
				/*
				sessmin=5;   sessmax=20;
				data_iat=0.1; sess_iat=30;
				InitJoinTime=10;
				*/
				ngrps = 10;
				
				TRACE printf("Mapp: MyObjId %d  Ngrps %d  SessMin %f  SessMax %f DataIat %f Sessiat %f InitJoinTime %d\n",my_objid,ngrps,sessmin,sessmax,data_iat,sess_iat,InitJoinTime);
				
				/*
				** Get the object id of the IP module and and the IP address of this host using that obj. ID
				*/
				ip_objid = op_topo_assoc (my_objid, OPC_TOPO_ASSOC_OUT, OPC_OBJMTYPE_MODULE, IP_STREAM);
				op_ima_obj_attr_get (ip_objid, "net_num0", &LocalAddress.NetNum );
				op_ima_obj_attr_get (ip_objid, "node_num0", &LocalAddress.NodeNum );
				
				NoOfMappPktsSent = 0;
				
				/*
				** Load the distribution pointers which are used for selecting the multicast group, termination
				** time, session interval time, and the session duration.
				*/
				grp_dist = op_dist_load( "uniform_int", 1,ngrps );
				time_dist = op_dist_load( "exponential", sess_iat,0 );
				term_dist = op_dist_load( "uniform", sessmin,sessmax );
				
				/*
				** Schedule an interrupt for sending a data packet from this host
				*/
				tim = op_dist_outcome(time_dist);
				/*
				op_intrpt_schedule_self( (op_sim_time() + tim/100 + InitJoinTime), join_term_intr );
				*/
				op_intrpt_schedule_self( (op_sim_time() +tim/10 +InitJoinTime), join_term_intr );
				/* Added by DG, 11/26/97, move this line from join_stat to here. */
				op_intrpt_schedule_self( (op_sim_time() +10+data_iat), send_data_intr );
				
				sess = 0;
				}


			/** state (init) exit executives **/
			FSM_STATE_EXIT_FORCED (0, state0_exit_exec, "init", "mapp () [init exit execs]")
				{
				}


			/** state (init) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;)
				/*---------------------------------------------------------*/



			/** state (idle) enter executives **/
			FSM_STATE_ENTER_UNFORCED (1, state1_enter_exec, "idle", "mapp () [idle enter execs]")
				{
				
				}


			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (3,mapp)


			/** state (idle) exit executives **/
			FSM_STATE_EXIT_UNFORCED (1, state1_exit_exec, "idle", "mapp () [idle exit execs]")
				{
				}


			/** state (idle) transition processing **/
			FSM_INIT_COND (SELF_INT0)
			FSM_TEST_COND (SELF_INT1)
			FSM_TEST_LOGIC ("idle")

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 2, state2_enter_exec, ;)
				FSM_CASE_TRANSIT (1, 3, state3_enter_exec, ;)
				}
				/*---------------------------------------------------------*/



			/** state (JOIN_TERM) enter executives **/
			FSM_STATE_ENTER_FORCED (2, state2_enter_exec, "JOIN_TERM", "mapp () [JOIN_TERM enter execs]")
				{
				/******************************************************************************************************
				** Process Model : mapp                                                                              **
				** State         : join_term                                                                         **
				**                                                                                                   **
				** This state joins a new session or terminates the current session that is currently registered to. **
				** It looks if the host has joined  any session and if it is not it selects a random group and joins **
				** to that session. This application has limitation that it can registered to only one session. This **
				** state will send a termination request if the application is currently registered to a session. It **
				** sends the  join and terminate requests  to the IGMP  module. This state schedules  interrupts for **
				** sending data,  terminate the session or joining  to a new session. This  application acts as both **
				** receiver and sender if  it joins to any multicast group. All  the data that is destined for  this **
				** group will be sent to the data traffic port that was implemented in the "Uniapp" module.          **
				**                                                                                                   **
				******************************************************************************************************/
				
				
				if( !sess )
				{
					/*
					** Join into a session if the application is not currently registered to any multicast session. 
					** If it is schedule  an interrupt for terminating  that session. If it is joining to a session 
					** schedule an interrupt for sending data to that session. If you are a application that do not 
					** want to send any data donot schedule the 'data_send_intr' interrupt 
					*/
					grp_id =  op_dist_outcome(grp_dist);
				
					pkptr = op_pk_create_fmt("MC_APP_CNTRL");
				
					op25_pk_nfd_set( pkptr,"join", JOIN_TRUE );
					op25_pk_nfd_set( pkptr,"terminate",TERM_FALSE );
					op25_pk_nfd_set( pkptr,"GRP_ID",grp_id );
					op_pk_send( pkptr, IGMP_STREAM );		  /*      Send the join request to IGMP module        */
				
					VL
					{
						printf("MAPP %fs, (%d.%d) Sending join %d pk \n",
							op_sim_time(),LocalAddress.NetNum,LocalAddress.NodeNum, grp_id );
					}
				
					sess=1; 
					/*
					** Interrupt for sending data pks to the session 
					*/
				        /*added by Jiemei*/
				/*	if (LocalAddress.NetNum==2 && LocalAddress.NodeNum==1) */
				
				/* Comment by DG, 11/26/97, instead of scheduling here, schedule data_intr in InitStat in order to send
				 data regularly with the same time interval.
					 op_intrpt_schedule_self( (op_sim_time() +10+data_iat), send_data_intr ); */
					/* 
					** Interrupt for terminating the existing session 
					*/
					tim = op_dist_outcome(term_dist);
					op_intrpt_schedule_self( (op_sim_time() + tim), join_term_intr );
				
					VL MADL
					{
						printf("Termination time is %f\n", tim );
					}
				}
				else
				{ 
					/* 
					** Terminate the current existing session and schedule an interrupt for joining another session 
					*/
					pkptr = op_pk_create_fmt("MC_APP_CNTRL");
					op25_pk_nfd_set( pkptr,"join", JOIN_FALSE );
					op25_pk_nfd_set( pkptr,"terminate",TERM_TRUE );
					op25_pk_nfd_set( pkptr,"GRP_ID",grp_id );
					op_pk_send( pkptr,IGMP_STREAM );		  /*     Send the terminte request to IGMP module     */
				
					VL
					{
				                printf("MAPP %fs, (%d.%d) Sending terminate %d pk \n",
				                        op_sim_time(),LocalAddress.NetNum,LocalAddress.NodeNum, grp_id );
					}
				
					sess--;
					/* 
					** Schedule an interrupt for joining to a new session 
					*/
					tim = op_dist_outcome(time_dist);
				 	op_intrpt_schedule_self( (op_sim_time() + tim), join_term_intr );
				}
				}


			/** state (JOIN_TERM) exit executives **/
			FSM_STATE_EXIT_FORCED (2, state2_exit_exec, "JOIN_TERM", "mapp () [JOIN_TERM exit execs]")
				{
				}


			/** state (JOIN_TERM) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;)
				/*---------------------------------------------------------*/



			/** state (data) enter executives **/
			FSM_STATE_ENTER_FORCED (3, state3_enter_exec, "data", "mapp () [data enter execs]")
				{
				/*******************************************************************************************************
				** Process Model : mapp                                                                               **
				** State         : data                                                                               **
				**                                                                                                    **
				** Check if the host is currently registered with a session, and if it is send an data packet to that **
				** session. Size of the  data packet is 500 bytes. This data packet is encapsulated into an IP packet **
				** and sent to IP module. The destination net in the IP packet is set to the multicast address( 500 ) **
				** and the destination node in the  IP packet is set to multicast Group ID  of the session that it is **
				** currently registered to. Interrupt is scheduled to send the next data packet.                      **
				**                                                                                                    **
				*******************************************************************************************************/
				
				if( sess )
				{ 
				
					App_Data* DataSent;    /*changed by Jiemei,Mar 27 97*/
					Packet* ip_pkptr;
				
					/* Changed by Jiemei, Mar 27 97*/
					DataSent=(App_Data *) op_prg_mem_alloc (sizeof(App_Data));   
					sprintf( DataSent->Message, "MAPP  %f Src %d %d Dest %d %d\n", op_sim_time(),
				             LocalAddress.NetNum, LocalAddress.NodeNum, 500, grp_id );
				
					/*
					** Create the data packet format and stuff the data into the packet pointer
					*/
				        pkptr = op_pk_create_fmt("Unicast_Appl");
				        op25_pk_nfd_set(pkptr, "UniData", DataSent, op_prg_mem_alloc, op_prg_mem_free, sizeof(App_Data) );
				    	data_len = op_pk_total_size_get( pkptr )/8;
				
					/*
					** Encapsulate the data packet into the IP datagram by filling the data packet pointer sender 
					** address, destination group, data length protocol ID and the time-to-live fields.
					*/
				    	ip_pkptr = op_pk_create_fmt("ip_dgram");
				    	op25_pk_nfd_set(ip_pkptr, "data", pkptr );
				    	op25_pk_nfd_set(ip_pkptr, "prot_id", UDP_PROTOCOL_ID );
				    	op_pk_bulk_size_set(ip_pkptr, data_len*8 );
					op25_pk_nfd_set(ip_pkptr, "dest_net", 500 );
					op25_pk_nfd_set(ip_pkptr, "dest_node", grp_id );
					op25_pk_nfd_set(ip_pkptr, "src_net", LocalAddress.NetNum );
				    	op25_pk_nfd_set(ip_pkptr, "src_node", LocalAddress.NodeNum );
					op25_pk_nfd_set(ip_pkptr, "orig_len", data_len );
				    	op25_pk_nfd_set(ip_pkptr, "frag_len", data_len );
				/*    op25_pk_nfd_set(ip_pkptr, "ttl", 2 );*/
				    	op25_pk_nfd_set(ip_pkptr, "ttl", 9);    /* changed by Jiemei*/
				    	op25_pk_nfd_set(ip_pkptr, "frag", 0 );
				
				TRACE	VL
					{
						printf("MAPP   %fs, (%d.%d) sending %d protocol packet to %d group\n", 
							op_sim_time(),LocalAddress.NetNum,LocalAddress.NodeNum,UDP_PROTOCOL_ID,grp_id);
				TRACE		op_pk_print(ip_pkptr);
					}
				
					/*
					** Write the number of data packets that are sent by this module to a probe
					*/
					PROBE_ON
					{
						NoOfMappPktsSent++;
						op_stat_local_write( CUMM_MAPP_PKT_SENT_STAT, NoOfMappPktsSent);
					}
				
				
					op_pk_send(ip_pkptr, IP_STREAM);     /*      Send the data packet to the IP module         */
				}
				
				/* 
				** Schedule an interrupt for the next data packet 
				*/
					op_intrpt_schedule_self( (op_sim_time() + data_iat), send_data_intr );
				}


			/** state (data) exit executives **/
			FSM_STATE_EXIT_FORCED (3, state3_exit_exec, "data", "mapp () [data exit execs]")
				{
				}


			/** state (data) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;)
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (0,mapp)
		}
	}

extern
#if defined (__cplusplus)
	"C"
#endif
	void Vos_Vnop (void);


Compcode
mapp_init (void ** gen_state_pptr)
	{
	int _block_origin = 0;
	static VosT_Cm_Obtype	obtype = OPC_NIL;

	FIN (mapp_init (gen_state_pptr))

	if (obtype == OPC_NIL)
		{
		/* Initialize memory management */
		if (Vos_Catmem_Register ("proc state vars (mapp)",
			sizeof (mapp_state), Vos_Vnop, &obtype) == VOSC_FAILURE)
			{
			FRET (OPC_COMPCODE_FAILURE)
			}
		}

	*gen_state_pptr = Vos_Catmem_Alloc (obtype, 1);
	if (*gen_state_pptr == OPC_NIL)
		{
		FRET (OPC_COMPCODE_FAILURE)
		}
	else
		{
		/* Initialize FSM handling */
		((mapp_state *)(*gen_state_pptr))->current_block = 0;

		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



void
mapp_diag (void)
	{
	/* No Diagnostic Block */
	}




void
mapp_terminate (void)
	{
	int _block_origin = __LINE__;

	FIN (mapp_terminate (void))

	if (1)
		{
		Packet*  pkptr;
		int in_strm,da1,da2,da3;
		FILE*  fil;
		

		/* Termination Block */


		BINIT
		

		/* End of Termination Block */

		}
	Vos_Catmem_Dealloc (pr_state_ptr);

	FOUT;
	}


/* Undefine shortcuts to state variables to avoid */
/* syntax error in direct access to fields of */
/* local variable prs_ptr in mapp_svar function. */
#undef my_objid
#undef ip_objid
#undef tim
#undef sessmin
#undef sessmax
#undef data_iat
#undef sess_iat
#undef InitJoinTime
#undef dest_net
#undef dest_node
#undef data_len
#undef grp_id
#undef sess
#undef ngrps
#undef grp_dist
#undef time_dist
#undef term_dist
#undef LocalAddress



void
mapp_svar (void * gen_ptr, const char * var_name, char ** var_p_ptr)
	{
	mapp_state		*prs_ptr;

	FIN (mapp_svar (gen_ptr, var_name, var_p_ptr))

	*var_p_ptr = (char *)VOS_NIL;
	prs_ptr = (mapp_state *)gen_ptr;

	if (Vos_String_Equal ("my_objid" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->my_objid);
		goto func_return;
		}
	if (Vos_String_Equal ("ip_objid" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->ip_objid);
		goto func_return;
		}
	if (Vos_String_Equal ("tim" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->tim);
		goto func_return;
		}
	if (Vos_String_Equal ("sessmin" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->sessmin);
		goto func_return;
		}
	if (Vos_String_Equal ("sessmax" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->sessmax);
		goto func_return;
		}
	if (Vos_String_Equal ("data_iat" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->data_iat);
		goto func_return;
		}
	if (Vos_String_Equal ("sess_iat" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->sess_iat);
		goto func_return;
		}
	if (Vos_String_Equal ("InitJoinTime" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->InitJoinTime);
		goto func_return;
		}
	if (Vos_String_Equal ("dest_net" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->dest_net);
		goto func_return;
		}
	if (Vos_String_Equal ("dest_node" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->dest_node);
		goto func_return;
		}
	if (Vos_String_Equal ("data_len" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->data_len);
		goto func_return;
		}
	if (Vos_String_Equal ("grp_id" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->grp_id);
		goto func_return;
		}
	if (Vos_String_Equal ("sess" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->sess);
		goto func_return;
		}
	if (Vos_String_Equal ("ngrps" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->ngrps);
		goto func_return;
		}
	if (Vos_String_Equal ("grp_dist" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->grp_dist);
		goto func_return;
		}
	if (Vos_String_Equal ("time_dist" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->time_dist);
		goto func_return;
		}
	if (Vos_String_Equal ("term_dist" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->term_dist);
		goto func_return;
		}
	if (Vos_String_Equal ("LocalAddress" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->LocalAddress);
		goto func_return;
		}

func_return:

	FOUT;
	}

