/* Process model C form file: tcp_gwy.pr.c */
/* Portions of this file copyright 1992, 1996, 1998 by MIL 3, Inc. */



/* This variable carries the header into the object file */
static const char tcp_gwy_pr_c [] = "MIL_3_Tfile_Hdr_ 60L 30A op_runsim 7 38FBBA91 38FBBA91 1 chrono.ite.gmu.edu vmukkama 0 0 none none 0 0 none 0 0 0 0 0 0";


/* OPNET system definitions */
#include <opnet.h>

#if defined (__cplusplus)
extern "C" {
#endif
FSM_EXT_DECS
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif


/* Header Block */

#define	PK_ARR	op_intrpt_type () == OPC_INTRPT_STRM
#define	SELF_INT0	(op_intrpt_type () == OPC_INTRPT_SELF  && op_intrpt_code () == 0)
#define	SELF_INT1	(op_intrpt_type () == OPC_INTRPT_SELF  && op_intrpt_code () == 1)

#define END_SIM		op_intrpt_type () ==  OPC_INTRPT_ENDSIM

extern int TCP;


/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		_fstack_local_info.last_line_passed = __LINE__ - _block_origin;
#define	BOUT	BIN
#define	BINIT	_fstack_local_info.last_line_passed = 0; _block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	/* State Variables */
	Objid	                  		my_id;
	Objid	                  		ip_objid;
	int	                    		sess;
	int	                    		Indep_Rou;
	double	                 		data_rec;
	int                     		net_num0;
	int                     		node_num0;
	int                     		net_num1;
	int                     		node_num1;
	int                     		net_num2;
	int                     		node_num2;
	int                     		net_num3;
	int                     		node_num3;
	int                     		net_num4;
	int                     		node_num4;
	} tcp_gwy_state;

#define pr_state_ptr            		((tcp_gwy_state*) SimI_Mod_State_Ptr)
#define my_id                   		pr_state_ptr->my_id
#define ip_objid                		pr_state_ptr->ip_objid
#define sess                    		pr_state_ptr->sess
#define Indep_Rou               		pr_state_ptr->Indep_Rou
#define data_rec                		pr_state_ptr->data_rec
#define net_num0                		pr_state_ptr->net_num0
#define node_num0               		pr_state_ptr->node_num0
#define net_num1                		pr_state_ptr->net_num1
#define node_num1               		pr_state_ptr->node_num1
#define net_num2                		pr_state_ptr->net_num2
#define node_num2               		pr_state_ptr->node_num2
#define net_num3                		pr_state_ptr->net_num3
#define node_num3               		pr_state_ptr->node_num3
#define net_num4                		pr_state_ptr->net_num4
#define node_num4               		pr_state_ptr->node_num4

/* This macro definition will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE
#define FIN_PREAMBLE	tcp_gwy_state *op_sv_ptr = pr_state_ptr;


/* No Function Block */

enum { _block_origin = __LINE__ };

#if defined (__cplusplus)
extern "C" {
#endif
	void tcp_gwy (void);
	Compcode tcp_gwy_init (void **);
	void tcp_gwy_diag (void);
	void tcp_gwy_terminate (void);
	void tcp_gwy_svar (void *, const char *, char **);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
tcp_gwy (void)
	{
	int _block_origin = 0;
	FIN (tcp_gwy ());
	if (1)
		{
		Packet  *pkptr,*ip_pkptr;
		int type,tmp_node,tmp_net,my_net,my_node;
		int pk_len;


		FSM_ENTER (tcp_gwy)

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (init) enter executives **/
			FSM_STATE_ENTER_FORCED (0, state0_enter_exec, "init", "tcp_gwy () [init enter execs]")
				{
				my_id = op_id_self();
				ip_objid = op_topo_assoc (my_id, OPC_TOPO_ASSOC_OUT,
				                OPC_OBJMTYPE_MODULE, 0);
				 
				/* Use the object id to get the address */
				op_ima_obj_attr_get (ip_objid, "net_num0", &net_num0);
				op_ima_obj_attr_get (ip_objid, "node_num0", &node_num0);
				op_ima_obj_attr_get (ip_objid, "net_num1", &net_num1);
				op_ima_obj_attr_get (ip_objid, "node_num1", &node_num1);
				op_ima_obj_attr_get (ip_objid, "net_num2", &net_num2);
				op_ima_obj_attr_get (ip_objid, "node_num2", &node_num2);
				op_ima_obj_attr_get (ip_objid, "net_num3", &net_num3);
				op_ima_obj_attr_get (ip_objid, "node_num3", &node_num3);
				op_ima_obj_attr_get (ip_objid, "net_num4", &net_num4);
				op_ima_obj_attr_get (ip_objid, "node_num4", &node_num4);
				op_ima_obj_attr_get (ip_objid, "Indep_Rou", &Indep_Rou);
				
				/*Added by Jiemei */
				
				printf("Gwy_Tcp:  MyObjId %d  net_num %d %d %d %d %d node_num %d %d %d %d %d Indep_Rou %d\n",my_id,net_num0,net_num1,net_num2,net_num3,net_num4,node_num0,node_num1,node_num2,node_num3,node_num4,Indep_Rou);
				}


			/** state (init) exit executives **/
			FSM_STATE_EXIT_FORCED (0, state0_exit_exec, "init", "tcp_gwy () [init exit execs]")
				{
				}


			/** state (init) transition processing **/
			FSM_INIT_COND ((1))
			FSM_TEST_COND (PK_ARR)
			FSM_TEST_LOGIC ("init")

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 1, state1_enter_exec, ;)
				FSM_CASE_TRANSIT (1, 2, state2_enter_exec, ;)
				}
				/*---------------------------------------------------------*/



			/** state (idle) enter executives **/
			FSM_STATE_ENTER_UNFORCED (1, state1_enter_exec, "idle", "tcp_gwy () [idle enter execs]")
				{
				}


			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (3,tcp_gwy)


			/** state (idle) exit executives **/
			FSM_STATE_EXIT_UNFORCED (1, state1_exit_exec, "idle", "tcp_gwy () [idle exit execs]")
				{
				}


			/** state (idle) transition processing **/
			FSM_INIT_COND (PK_ARR)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("idle")

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 2, state2_enter_exec, ;)
				FSM_CASE_TRANSIT (1, 1, state1_enter_exec, ;)
				}
				/*---------------------------------------------------------*/



			/** state (pk_arr) enter executives **/
			FSM_STATE_ENTER_FORCED (2, state2_enter_exec, "pk_arr", "tcp_gwy () [pk_arr enter execs]")
				{
				ip_pkptr  = op_pk_get (op_intrpt_strm ());
				op_pk_nfd_get(ip_pkptr,"data", &pkptr);
				
				op_pk_nfd_get(pkptr,"type",&type);
				 
				if(type == 1)
				{       /*send back a accept for TCP connection*/
				        op_pk_nfd_get(ip_pkptr,"src_node",&tmp_node);
				        op_pk_nfd_get(ip_pkptr,"src_net",&tmp_net);
				        op_pk_nfd_get(ip_pkptr,"dest_node",my_node);
				        op_pk_nfd_get(ip_pkptr,"dest_net", my_net);
				        op25_pk_nfd_set(ip_pkptr,"src_node",my_node);
				        op25_pk_nfd_set(ip_pkptr,"src_net",my_net);
				if((my_net != net_num0 && my_node != node_num0) || (my_net != net_num1 && my_node != node_num1) || 
				         (my_net != net_num2 && my_node != node_num2) || (my_net != net_num3 && my_node != node_num3) 
				             || (my_net != net_num4 && my_node != node_num4))
				               op_sim_end("Tcp  at gwy is getting a pk which is not for him","","","");
				
				
				 
				        op25_pk_nfd_set(ip_pkptr,"dest_net", tmp_net);
				        op25_pk_nfd_set(ip_pkptr,"dest_node",tmp_node);
				        op25_pk_nfd_set(ip_pkptr,"ttl",10);
				 
				        op25_pk_nfd_set(pkptr,"type", 2);
				        pk_len=op_pk_total_size_get(pkptr);
				        op25_pk_nfd_set(ip_pkptr,"data",pkptr);
				        op_pk_bulk_size_set(ip_pkptr,pk_len);
				/*        op_pk_send(pkptr,0);
				*/
					op_pk_send(ip_pkptr,0);
				}
				 
				else
				if(type == 0) { op_pk_destroy(pkptr);   op_pk_destroy(ip_pkptr);}
				
				
				 if(type == 2 || type == 3)op_sim_end("Tcp at gwy is getting a conn ack/n-ack why!!!","","","");
				
				
				
				}


			/** state (pk_arr) exit executives **/
			FSM_STATE_EXIT_FORCED (2, state2_exit_exec, "pk_arr", "tcp_gwy () [pk_arr exit execs]")
				{
				}


			/** state (pk_arr) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;)
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (0,tcp_gwy)
		}
	}

extern
#if defined (__cplusplus)
	"C"
#endif
	void Vos_Vnop (void);


Compcode
tcp_gwy_init (void ** gen_state_pptr)
	{
	int _block_origin = 0;
	static VosT_Cm_Obtype	obtype = OPC_NIL;

	FIN (tcp_gwy_init (gen_state_pptr))

	if (obtype == OPC_NIL)
		{
		/* Initialize memory management */
		if (Vos_Catmem_Register ("proc state vars (tcp_gwy)",
			sizeof (tcp_gwy_state), Vos_Vnop, &obtype) == VOSC_FAILURE)
			{
			FRET (OPC_COMPCODE_FAILURE)
			}
		}

	*gen_state_pptr = Vos_Catmem_Alloc (obtype, 1);
	if (*gen_state_pptr == OPC_NIL)
		{
		FRET (OPC_COMPCODE_FAILURE)
		}
	else
		{
		/* Initialize FSM handling */
		((tcp_gwy_state *)(*gen_state_pptr))->current_block = 0;

		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



void
tcp_gwy_diag (void)
	{
	/* No Diagnostic Block */
	}




void
tcp_gwy_terminate (void)
	{
	int _block_origin = __LINE__;

	FIN (tcp_gwy_terminate (void))

	if (1)
		{
		Packet  *pkptr,*ip_pkptr;
		int type,tmp_node,tmp_net,my_net,my_node;
		int pk_len;

		/* No Termination Block */

		}
	Vos_Catmem_Dealloc (pr_state_ptr);

	FOUT;
	}


/* Undefine shortcuts to state variables to avoid */
/* syntax error in direct access to fields of */
/* local variable prs_ptr in tcp_gwy_svar function. */
#undef my_id
#undef ip_objid
#undef sess
#undef Indep_Rou
#undef data_rec
#undef net_num0
#undef node_num0
#undef net_num1
#undef node_num1
#undef net_num2
#undef node_num2
#undef net_num3
#undef node_num3
#undef net_num4
#undef node_num4



void
tcp_gwy_svar (void * gen_ptr, const char * var_name, char ** var_p_ptr)
	{
	tcp_gwy_state		*prs_ptr;

	FIN (tcp_gwy_svar (gen_ptr, var_name, var_p_ptr))

	*var_p_ptr = (char *)VOS_NIL;
	prs_ptr = (tcp_gwy_state *)gen_ptr;

	if (Vos_String_Equal ("my_id" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->my_id);
		goto func_return;
		}
	if (Vos_String_Equal ("ip_objid" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->ip_objid);
		goto func_return;
		}
	if (Vos_String_Equal ("sess" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->sess);
		goto func_return;
		}
	if (Vos_String_Equal ("Indep_Rou" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->Indep_Rou);
		goto func_return;
		}
	if (Vos_String_Equal ("data_rec" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->data_rec);
		goto func_return;
		}
	if (Vos_String_Equal ("net_num0" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->net_num0);
		goto func_return;
		}
	if (Vos_String_Equal ("node_num0" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->node_num0);
		goto func_return;
		}
	if (Vos_String_Equal ("net_num1" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->net_num1);
		goto func_return;
		}
	if (Vos_String_Equal ("node_num1" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->node_num1);
		goto func_return;
		}
	if (Vos_String_Equal ("net_num2" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->net_num2);
		goto func_return;
		}
	if (Vos_String_Equal ("node_num2" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->node_num2);
		goto func_return;
		}
	if (Vos_String_Equal ("net_num3" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->net_num3);
		goto func_return;
		}
	if (Vos_String_Equal ("node_num3" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->node_num3);
		goto func_return;
		}
	if (Vos_String_Equal ("net_num4" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->net_num4);
		goto func_return;
		}
	if (Vos_String_Equal ("node_num4" , var_name))
		{
		*var_p_ptr = (char *) (&prs_ptr->node_num4);
		goto func_return;
		}

func_return:

	FOUT;
	}

