/* dpt_ecc.ps.c */
/* Default error correction model for pt-to-pt link Transceiver Pipeline */

/****************************************/
/*		  Copyright (c) 1993			*/
/*			by MIL 3, Inc.				*/
/*		(A Delaware Corporation)		*/
/*	3400 International Drive,  N.W.		*/
/*		Washington, D.C., U.S.A.		*/
/*			All Rights Reserved.		*/
/****************************************/

#include <opnet.h>
extern Anvid vid;


void
li_anim_dpt_ecc (pkptr)
	Packet*		pkptr;
	{
		/*Pradeep's============*/
          Objid       link_objid;
          char        link_name [128];
                /*Pradeep's============*/


	Objid		rx_obid;
	int			pklen, num_errs, accept;
	double		ecc_thresh;

	/** Test if packet arriving over point-to-point link is		**/
	/** acceptable for recpetion or if it should be discarded.	**/
	FIN (dpt_ecc (pkptr))

	/* Do not accept packets that were received	*/
	/* when the node was disabled.				*/
	if (op_td_is_set (pkptr, OPC_TDA_PT_ND_FAIL))
		accept = OPC_FALSE;
	else
		{
		/* Obtain object id of receiver accepting transmission. */
		rx_obid = op_td_get_int (pkptr, OPC_TDA_PT_RX_OBJID);
	
		/* Obtain the error correction threshold of the receiver. */
		op_ima_obj_attr_get (rx_obid, "ecc threshold", &ecc_thresh);
	
		/* Obtain length of packet. */
		pklen = op_pk_total_size_get (pkptr);
	
		/* Obtain number of errors in packet. */
		num_errs = op_td_get_int (pkptr, OPC_TDA_PT_NUM_ERRORS);
	
		/* Test if bit errors exceed threshold. */
		if (pklen == 0)
			accept = OPC_TRUE;
		else	
			accept = ((((double) num_errs) / pklen) <= ecc_thresh) ? OPC_TRUE : OPC_FALSE;
		}	

	/* Place flag indicating acceptance/rejection in packet trans. data attr.*/
	op_td_set_int (pkptr, OPC_TDA_PT_PK_ACCEPT, accept);

      /**************************/
      /* Begin animation calls. */
      /**************************/
      /* Obtain the object id of the link on      */
      /* on which this packet is traversing.      */
      link_objid = op_td_get_int (pkptr, OPC_TDA_PT_LINK_OBJID);
 
      /* Obtain the link name.                    */
      op_ima_obj_attr_get (link_objid, "name", link_name);
 
      /* Reset the link color to white.           */
      op_anim_ime_nobj_update (vid, OPC_ANIM_OBJTYPE_SIMPLINK, link_name,
          OPC_ANIM_OBJ_ATTR_COLOR, OPC_ANIM_COLOR_WHITE, OPC_EOL);
 
      /************************/
      /* End animation calls. */
      /************************/

	FOUT
	}                
