/* Process model C form file: my_sink.pr.c */
/* Portions of this file copyright 1992, 1996, 1998 by MIL 3, Inc. */



/* This variable carries the header into the object file */
static const char my_sink_pr_c [] = "MIL_3_Tfile_Hdr_ 60L 30A op_runsim 7 38FBBA7E 38FBBA7E 1 chrono.ite.gmu.edu vmukkama 0 0 none none 0 0 none 0 0 0 0 0 0";


/* OPNET system definitions */
#include <opnet.h>

#if defined (__cplusplus)
extern "C" {
#endif
FSM_EXT_DECS
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif

#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		_fstack_local_info.last_line_passed = __LINE__ - _block_origin;
#define	BOUT	BIN
#define	BINIT	_fstack_local_info.last_line_passed = 0; _block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	} my_sink_state;

#define pr_state_ptr            		((my_sink_state*) SimI_Mod_State_Ptr)

/* This macro definition will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE
#define FIN_PREAMBLE	my_sink_state *op_sv_ptr = pr_state_ptr;


/* No Function Block */

enum { _block_origin = __LINE__ };

#if defined (__cplusplus)
extern "C" {
#endif
	void my_sink (void);
	Compcode my_sink_init (void **);
	void my_sink_diag (void);
	void my_sink_terminate (void);
	void my_sink_svar (void *, const char *, char **);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
my_sink (void)
	{
	int _block_origin = 0;
	FIN (my_sink ());
	if (1)
		{


		FSM_ENTER (my_sink)

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (DISCARD) enter executives **/
			FSM_STATE_ENTER_UNFORCED (0, state0_enter_exec, "DISCARD", "my_sink () [DISCARD enter execs]")
				{
				op_pk_destroy (op_pk_get (op_intrpt_strm ()));
				}


			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (1,my_sink)


			/** state (DISCARD) exit executives **/
			FSM_STATE_EXIT_UNFORCED (0, state0_exit_exec, "DISCARD", "my_sink () [DISCARD exit execs]")
				{
				}


			/** state (DISCARD) transition processing **/
			FSM_TRANSIT_FORCE (0, state0_enter_exec, ;)
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (0,my_sink)
		}
	}

extern
#if defined (__cplusplus)
	"C"
#endif
	void Vos_Vnop (void);


Compcode
my_sink_init (void ** gen_state_pptr)
	{
	int _block_origin = 0;
	static VosT_Cm_Obtype	obtype = OPC_NIL;

	FIN (my_sink_init (gen_state_pptr))

	if (obtype == OPC_NIL)
		{
		/* Initialize memory management */
		if (Vos_Catmem_Register ("proc state vars (my_sink)",
			sizeof (my_sink_state), Vos_Vnop, &obtype) == VOSC_FAILURE)
			{
			FRET (OPC_COMPCODE_FAILURE)
			}
		}

	*gen_state_pptr = Vos_Catmem_Alloc (obtype, 1);
	if (*gen_state_pptr == OPC_NIL)
		{
		FRET (OPC_COMPCODE_FAILURE)
		}
	else
		{
		/* Initialize FSM handling */
		((my_sink_state *)(*gen_state_pptr))->current_block = 0;

		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



void
my_sink_diag (void)
	{
	/* No Diagnostic Block */
	}




void
my_sink_terminate (void)
	{
	int _block_origin = __LINE__;

	FIN (my_sink_terminate (void))

	Vos_Catmem_Dealloc (pr_state_ptr);

	FOUT;
	}




void
my_sink_svar (void * gen_ptr, const char * var_name, char ** var_p_ptr)
	{

	FIN (my_sink_svar (gen_ptr, var_name, var_p_ptr))

	*var_p_ptr = (char *)VOS_NIL;

	FOUT;
	}

